QuTiP: Quantum Toolbox in Python
================================

[A. Pitchford](https://github.com/ajgpitch),
[C. Granade](https://github.com/cgranade),
[A. Grimsmo](https://github.com/arnelg),
[N. Shammah](https://github.com/nathanshammah),
[S. Ahmed](https://github.com/quantshah),
[N. Lambert](https://github.com/nwlambert),
[E. Giguère](https://github.com/ericgig),
[B. Li](https://github.com/boxili),
[J. Lishman](https://github.com/jakelishman),
[S. Cross](https://github.com/hodgestar),
[A. Galicia](https://github.com/AGaliciaMartinez),
[P. D. Nation](https://github.com/nonhermitian),
and [J. R. Johansson](https://github.com/jrjohansson)

[![Build Status](https://github.com/qutip/qutip/actions/workflows/tests.yml/badge.svg?branch=master)](https://github.com/qutip/qutip/actions/workflows/tests.yml)
[![Coverage Status](https://img.shields.io/coveralls/qutip/qutip.svg?logo=Coveralls)](https://coveralls.io/r/qutip/qutip)
[![Maintainability](https://api.codeclimate.com/v1/badges/df502674f1dfa1f1b67a/maintainability)](https://codeclimate.com/github/qutip/qutip/maintainability)
[![license](https://img.shields.io/badge/license-New%20BSD-blue.svg)](https://opensource.org/licenses/BSD-3-Clause)  
[![PyPi Downloads](https://img.shields.io/pypi/dm/qutip?label=downloads%20%7C%20pip&logo=PyPI)](https://pypi.org/project/qutip)
[![Conda-Forge Downloads](https://img.shields.io/conda/dn/conda-forge/qutip?label=downloads%20%7C%20conda&logo=Conda-Forge)](https://anaconda.org/conda-forge/qutip)

QuTiP is open-source software for simulating the dynamics of closed and open quantum systems.
It uses the excellent Numpy, Scipy, and Cython packages as numerical backends, and graphical output is provided by Matplotlib.
QuTiP aims to provide user-friendly and efficient numerical simulations of a wide variety of quantum mechanical problems, including those with Hamiltonians and/or collapse operators with arbitrary time-dependence, commonly found in a wide range of physics applications.
QuTiP is freely available for use and/or modification, and it can be used on all Unix-based platforms and on Windows.
Being free of any licensing fees, QuTiP is ideal for exploring quantum mechanics in research as well as in the classroom.

Support
-------

[![Unitary Fund](https://img.shields.io/badge/Supported%20By-UNITARY%20FUND-brightgreen.svg?style=flat)](https://unitary.fund)
[![Powered by NumFOCUS](https://img.shields.io/badge/powered%20by-NumFOCUS-orange.svg?style=flat&colorA=E1523D&colorB=007D8A)](https://numfocus.org)

We are proud to be affiliated with [Unitary Fund](https://unitary.fund) and [numFOCUS](https://numfocus.org).
QuTiP development is supported by [Nori's lab](https://dml.riken.jp/) at RIKEN, by the University of Sherbrooke, and by Aberystwyth University, [among other supporting organizations](https://qutip.org/#supporting-organizations).


Installation
------------

[![Pip Package](https://img.shields.io/pypi/v/qutip?logo=PyPI)](https://pypi.org/project/qutip)
[![Conda-Forge Package](https://img.shields.io/conda/vn/conda-forge/qutip?logo=Conda-Forge)](https://anaconda.org/conda-forge/qutip)

QuTiP is available on both `pip` and `conda` (the latter in the `conda-forge` channel).
You can install QuTiP from `pip` by doing

```bash
pip install qutip
```

to get the minimal installation.
You can instead use the target `qutip[full]` to install QuTiP with all its optional dependencies.
For more details, including instructions on how to build from source, see [the detailed installation guide in the documentation](https://qutip.org/docs/latest/installation.html).

All back releases are also available for download in the [releases section of this repository](https://github.com/qutip/qutip/releases), where you can also find per-version changelogs.
For the most complete set of release notes and changelogs for historic versions, see the [changelog](https://qutip.org/docs/latest/changelog.html) section in the documentation.


Documentation
-------------

The documentation for official releases, in HTML and PDF formats, can be found in the [documentation section of the QuTiP website](https://qutip.org/documentation.html).
The latest development documentation is available in this repository in the `doc` folder.

A [selection of demonstration notebooks is available](https://qutip.org/tutorials.html), which demonstrate some of the many features of QuTiP.
These are stored in the [qutip/qutip-notebooks repository](https://github.com/qutip/qutip-notebooks) here on GitHub.
You can run the notebooks online using myBinder: [![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/qutip/qutip-notebooks/master?filepath=index.ipynb)

Contribute
----------

You are most welcome to contribute to QuTiP development by forking this repository and sending pull requests, or filing bug reports at the [issues page](https://github.com/qutip/qutip/issues).
You can also help out with users' questions, or discuss proposed changes in the [QuTiP discussion group](https://groups.google.com/g/qutip).
All code contributions are acknowledged in the [contributors](https://qutip.org/docs/latest/contributors.html) section in the documentation.

For more information, including technical advice, please see the ["contributing to QuTiP development" section of the documentation](https://qutip.org/docs/latest/development/contributing.html).


Citing QuTiP
------------

If you use QuTiP in your research, please cite the original QuTiP papers that are available [here](https://dml.riken.jp/?s=QuTiP).

################################
# QuTiP README FILE FOR CPC
# Version: 2.2.0
# Released: 2013/03/01
# P.D. Nation and J.R. Johansson
################################


USERS GUIDE
-----------        
An in-depth user guide, including installation instructions, 
may be found at the QuTiP homepage:

http://code.google.com/p/qutip/ 
        
        
DEMO SCRIPTS
------------
QuTiP contains a collection of built-in demo scripts that 
may be called from the Python command line via:
    
>>> from qutip import *
>>> demos()


FILES LIST
----------
COPYING.txt                         # Copy of GPL-3.
INSTALL.txt                         # Installation instructions.
README.txt                          # This file for Comp. Phys. Comm.
RELEASE.txt                         # Release notes for QuTiP.
setup.py                            # QuTiP Python installation script.

qutip/
        __init__.py                 # Initialize qutip modules.
        _reset.py                   # Resets global QuTiP settings
        _version.py                 # Holds qutip version information.
        about.py                    # Calls about box.
        bloch-redfield.py           # Bloch-Redfield master equation.
        Bloch.py                    # Bloch sphere plot.
        Bloch3d.py                  # 3D Bloch sphere plot.
        continuous_variables.py     # Continuous variables routines.
        correlation.py              # Two-time correlation functions.    
        demos.py                    # Runs demos GUI or command line.
        entropy.py                  # Various entropy measures.
        eseries.py                  # Exponential series object.
        essolve.py                  # Exponential series ODE solver.
        expect.py                   # Calculates expectation values.
        fileio.py                   # Saving and loading data.
        floquet.py                  # Floquet-Markov master equation.
        gates.py                    # Quantum computation gates.
        graph.py                    # Visualization scripts.
        ipynbtools.py               # Tools for QuTiP in IPython notebooks.
        istests.py                  # Properties of a Qobj object.
        mcsolve.py                  # Monte-Carlo trajectory solver.
        mesolve.py                  # Lindblad master equation solver.        
        metrics.py                  # Density matrix metrics.
        odechecks.py                # Checks for ODE inputs.
        odeconfig.py                # Holds ODE data.
        Odeoptions.py               # Class of options for ODE solvers.
        Odedata.py                  # ODE output data class.
        operators.py                # Commonly used quantum operators.
        orbital.py                  # Angular wave function on a sphere.
        parfor.py                   # Parallel for-loop
        partial_transpose.py        # Partial transpose routine.
        propagator.py               # Propagator U(t) for density matrix.
        ptrace.py                   # Partial trace of a composite object.
        Qobj.py                     # Main quantum object class.
        qstate.py                   # Generates coupled states of qubits. 
        random_objects.py           # Random quantum operators and states.
        rhs_generate.py             # Generates Cython code at runtime.
        sesolve.py                  # Module for Schrodinger solvers.
        simdiag.py                  # Simultaneous diagonalization.
        sparse.py                   # Sparse eigensolvers.
        sphereplot.py               # Plots spherical wave functions.
        states.py                   # State vectors and density matrices.
        steady.py                   # Steady state evolution.
        stochastic.py               # Module for SDE solvers.
        superoperator.py            # Superoperators for Louvillian.
        tensor.py                   # Generates composite quantum objects.
        testing.py                  # Module for running QuTiP unit tests.
        three_level_atom.py         # Operators for three-level atoms.
        tomography.py               # Quantum process tomography functions.
        utilities.py                # Collection of utility functions.
        visualization.py            # Various visualization functions.
        wigner.py                   # Wigner function and Q functions.
    
        cyQ/
            __init__.py             # Initialize cyQ modules.
            codegen.py              # Class to auto gen. Cython files.
            spmatfuncs.c            # C file gen. from spmatfuncs.pyx.
            spmatfuncs.pyx          # Cython base matrix utils.
            setup.py                # Setup file for *.pyx -> *.c.
    
    examples/
            __init__.py             # Initialize examples modules.
            ex_10.py                # Demo script.
            ex_11.py                # Demo script.
            ex_12.py                # Demo script.
            ex_13.py                # Demo script.
            ex_14.py                # Demo script.
            ex_15.py                # Demo script.
            ex_16.py                # Demo script.
            ex_17.py                # Demo script.
            ex_18.py                # Demo script.
            ex_19.py                # Demo script.
            ex_20.py                # Demo script.
            ex_21.py                # Demo script.
            ex_22.py                # Demo script.
            ex_23.py                # Demo script.
            ex_24.py                # Demo script.
            ex_25.py                # Demo script.
            ex_26.py                # Demo script.
            ex_27.py                # Demo script.
            ex_30.py                # Demo script.
            ex_31.py                # Demo script.
            ex_32.py                # Demo script.
            ex_33.py                # Demo script.
            ex_34.py                # Demo script.
            ex_40.py                # Demo script.
            ex_41.py                # Demo script.
            ex_42.py                # Demo script.
            ex_43.py                # Demo script.
            ex_50.py                # Demo script.
            examples_text.py        # List of demos
            exconfig.py             # Examples config file.
    
    gui/
            __init__.py             # Initialize GUI modules.
            AboutBox.py             # QuTiP About box.
            Examples.py             # Demos GUI or command line. 
            icon.png                # Icon for GUI Windows.
            logo.png                # QuTiP logo used in About box.
            ProgressBar.py          # Progress bar GUI.
            syntax.py               # Syntax highlighting.

    tests/
            __init__.py             # Initialize testing modules.
            test_basis_trans.py     # Basis transformation test scripts.
            test_eigenstates.py     # Eigenstate/eigenvalue test scripts.
            test_entropy.py         # Entropy test scripts.
            test_fileio.py          # Read & write file test scripts.
            test_mcsolve.py         # Monte-Carlo solver tests scripts.
            test_mesolve.py         # Lindlad master equation tests.
            test_odechecks.py       # ODE configuration test scripts.
            test_operators.py       # Quantum operator test scripts.
            test_Qobj.py            # Qobj test scripts.
            test_qubit_evolve.py    # Test script for qubit dynamics.  
            test_rand.py            # Random operator/state test scripts.
            test_sp_eigs.py         # Sparse/Dense eigenvalue/vector test.
            test_states.py          # Quantum state test scripts.
            test_steadystate.py     # Steadystate solver test scripts.
            test_superoperator.py   # Quantum superoperator test scripts.
            test_wigner.py          # Wigner function test scripts.

Repository for QuTiP documentation
==================================

This repository contains the source files for the QuTiP documentation.

For pre-built documentation, see https://www.qutip.org/documentation.html

Building
--------

The main Python requirements for the documentation are `sphinx`, `sphinx-gallery`, `sphinx_rtd_theme`, `numpydoc` and `ipython`.
You should build or install the version of QuTiP you want to build the documentation against in the same environment.
You will also need a sensible copy of `make`, and if you want to build the LaTeX documentation then also a `pdflatex` distribution.
As of 2021-04-20, the `conda` recipe for `sphinx_rtd_theme` is rather old compared to the `pip` version, so it's recommended to use a mostly `pip`-managed environment to do the documentation build.

The simplest way to get a functional build environment is to use the `requirements.txt` file in this repository, which completely defines a known-good `pip` environment (tested on Python 3.8, but not necessarily limited to it).
If you typically use conda, the way to do this is
```bash
$ conda create -n qutip-doc-build python=3.8
$ conda activate qutip-doc-build
$ pip install -r /path/to/qutip/doc/requirements.txt
```
You will also need to build or install the main QuTiP library in the same environment.
If you simply want to build the documentation without editing the main library, you can install a release version of QuTiP with `pip install qutip`.
Otherwise, refer to [the main repository](https://github.com/qutip/qutip) for the current process to build from source.
You need to have the optional QuTiP dependency `Cython` to build the documentation, but this is included in this repository's `requirements.txt` so you do not need to do anything separately.

After you have done this, you can effect the build with `make`.
The targets you might want are `html`, `latexpdf` and `clean`, which build the HTML pages, build the PDFs, and delete all built files respectively.
For example, to build the HTML files only, use
```bash
$ make html
```

*Note (2021-04-20):* the documentation build is currently broken on Windows due to incompatibilities in the main library in multiprocessing components.

Writing User Guides
-------------------

The user guide provides an overview of QuTiP's functionality. The guide is composed of individual reStructuredText (`.rst`) files which each get rendered as a webpage. Each page typically tackles one area of functionality. To learn more about how to write `.rst` files, it is useful to follow the [Sphinx Guide](https://www.sphinx-doc.org/en/master/usage/index.html).

The documentation build also utilizes a number of [Sphinx Extensions](https://www.sphinx-doc.org/en/master/usage/extensions/index.html) including but not limited to
[doctest](https://www.sphinx-doc.org/en/master/usage/extensions/doctest.html), [autodoc](https://www.sphinx-doc.org/en/master/usage/extensions/autodoc.html), [sphinx gallery](https://sphinx-gallery.github.io/stable/index.html), [plot](https://matthew-brett.github.io/nb2plots/nbplots.html#module-nb2plots.nbplots). Additional extensions can be configured in the `conf.py` file.

Tests can also be run on examples in the documentation using the doctest extension
and plots are generated using the `plot` directive. For more specific
guidelines on how to incorporate code examples into the guide, refer to (insert reference).

module linked_list
  !
  ! Linked list module
  !

  use qutraj_precision

  implicit none

  type llnode_real
    type(llnode_real), pointer :: next=>null()
    real(wp) :: a
  end type

  type llnode_int
    type(llnode_int), pointer :: next=>null()
    integer :: a
  end type

  type linkedlist_real
    type(llnode_real), pointer :: head=>null(), tail=>null()
    integer :: nelements = 0
  end type

  type linkedlist_int
    type(llnode_int), pointer :: head=>null(), tail=>null()
    integer :: nelements = 0
  end type

  interface new
    module procedure init_node_real
    module procedure init_node_int
  end interface

  interface finalize
    module procedure finalize_ll_real
    module procedure finalize_ll_int
  end interface

  interface append
    module procedure ll_append_real
    module procedure ll_append_int
  end interface

  interface ll_to_array
    module procedure ll_to_array_real
    module procedure ll_to_array_int
  end interface

  contains

  subroutine init_node_real(node,a)
    type(llnode_real), pointer, intent(inout) :: node
    real(wp) :: a
    allocate(node)
    node%a=a
    node%next=>null()
  end subroutine

  subroutine init_node_int(node,a)
    type(llnode_int), pointer, intent(inout) :: node
    integer :: a
    allocate(node)
    node%a=a
    node%next=>null()
  end subroutine

  subroutine ll_append_real(list, a)
    !Add a node to the end of the list.
    type(linkedlist_real), intent(inout) :: list
    real(wp), intent(in) :: a
    type(llnode_real), pointer :: node
    call new(node,a)
    if (associated(list%head)) then
      list%tail%next => node  
      node%next => null()  
      list%tail => node  
    else
      list%head => node    
      list%tail => node  
      list%tail%next => null()  
    end if
    list%nelements = list%nelements+1
  end subroutine

  subroutine ll_append_int(list, a)
    !Add a node to the end of the list.
    type(linkedlist_int), intent(inout) :: list
    integer, intent(in) :: a
    type(llnode_int), pointer :: node
    call new(node,a)
    if (associated(list%head)) then
      list%tail%next => node  
      node%next => null()  
      list%tail => node  
    else
      list%head => node    
      list%tail => node  
      list%tail%next => null()  
    end if
    list%nelements = list%nelements+1
  end subroutine

  subroutine ll_to_array_real(list, table)
    ! Makes an array out of the list
    ! while deleting the list nodes!
    type(linkedlist_real), intent(inout) :: list
    real(wp), allocatable, intent(out) :: table(:)
    type(llnode_real), pointer :: move, tmp
    integer :: i
    ! Check if empty.
    if (.not. associated(list%head)) then
      return
    else
      ! Allocate table
      allocate(table(list%nelements))
      ! Load the table with the list.
      move=>list%head
      do i=1, list%nelements
        table(i)=move%a
        if (associated(move%next)) then
          tmp=>move
          move=>move%next
          deallocate(tmp)
          nullify(tmp)
        endif
      end do
      list%head => null()
      list%tail => null()
    end if
  end subroutine

  subroutine ll_to_array_int(list, table)
    ! Makes an array out of the list
    ! while deleting the list nodes!
    type(linkedlist_int), intent(inout) :: list
    integer, allocatable, intent(out) :: table(:)
    type(llnode_int), pointer :: move, tmp
    integer :: i
    ! Check if empty.
    if (.not. associated(list%head)) then
      return
    else
      ! Allocate table
      allocate(table(list%nelements))
      ! Load the table with the list.
      move=>list%head
      do i=1, list%nelements
        table(i)=move%a
        if (associated(move%next)) then
          tmp=>move
          move=>move%next
          deallocate(tmp)
          nullify(tmp)
        endif
      end do
      list%head => null()
      list%tail => null()
    end if
  end subroutine

  !Delete all elements in a list.  Leaves the list initialized.
  subroutine finalize_ll_real(list)
  implicit none
    type(linkedlist_real), intent(inout) :: list
    type(llnode_real), pointer :: move
    do
      !Check if list empty.
      if (.not. associated(list%head)) then
        exit
      else
        !Check if more than 1 node.
        if (associated(list%head%next)) then !more than one node.
          move => list%head
          list%head => list%head%next
          move%next => null()
        else
          move => list%head
          list%head => null()
          list%tail => null()
        end if
        !call ll_del_first(list,move)
        deallocate(move)
        nullify(move)
      end if      
    end do
  end subroutine

  subroutine finalize_ll_int(list)
  implicit none
    type(linkedlist_int), intent(inout) :: list
    type(llnode_int), pointer :: move
    do
      !Check if list empty.
      if (.not. associated(list%head)) then
        exit
      else
        !Check if more than 1 node.
        if (associated(list%head%next)) then !more than one node.
          move => list%head
          list%head => list%head%next
          move%next => null()
        else
          move => list%head
          list%head => null()
          list%tail => null()
        end if
        !call ll_del_first(list,move)
        deallocate(move)
        nullify(move)
      end if      
    end do
  end subroutine

end module linked_list

! A Fortran-program for MT19937: Real number version
 
! Code converted using TO_F90 by Alan Miller
! Date: 1999-11-26  Time: 17:09:23
! Latest revision - 5 February 2002
! A new seed initialization routine has been added based upon the new
! C version dated 26 January 2002.
! This version assumes that integer overflows do NOT cause crashes.
! This version is compatible with Lahey's ELF90 compiler,
! and should be compatible with most full Fortran 90 or 95 compilers.
! Notice the strange way in which umask is specified for ELF90.
 
!   genrand() generates one pseudorandom real number (double) which is
! uniformly distributed on [0,1]-interval, for each call.
! sgenrand(seed) set initial values to the working area of 624 words.
! Before genrand(), sgenrand(seed) must be called once.  (seed is any 32-bit
! integer except for 0).
! Integer generator is obtained by modifying two lines.
!   Coded by Takuji Nishimura, considering the suggestions by
! Topher Cooper and Marc Rieffel in July-Aug. 1997.

! This library is free software; you can redistribute it and/or modify it
! under the terms of the GNU Library General Public License as published by
! the Free Software Foundation; either version 2 of the License, or (at your
! option) any later version.   This library is distributed in the hope that
! it will be useful, but WITHOUT ANY WARRANTY; without even the implied
! warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
! See the GNU Library General Public License for more details.
! You should have received a copy of the GNU Library General Public License
! along with this library; if not, write to the Free Foundation, Inc.,
! 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

! Copyright (C) 1997 Makoto Matsumoto and Takuji Nishimura.
! When you use this, send an email to: matumoto@math.keio.ac.jp
! with an appropriate reference to your work.

!***********************************************************************
! Fortran translation by Hiroshi Takano.  Jan. 13, 1999.

!   genrand()      -> double precision function grnd()
!   sgenrand(seed) -> subroutine sgrnd(seed)
!                     integer seed

! This program uses the following standard intrinsics.
!   ishft(i,n): If n > 0, shifts bits in i by n positions to left.
!               If n < 0, shifts bits in i by n positions to right.
!   iand (i,j): Performs logical AND on corresponding bits of i and j.
!   ior  (i,j): Performs inclusive OR on corresponding bits of i and j.
!   ieor (i,j): Performs exclusive OR on corresponding bits of i and j.

!***********************************************************************

MODULE mt19937
use qutraj_precision

IMPLICIT NONE
!INTEGER, PARAMETER :: dp = SELECTED_REAL_KIND(12, 60)

! Period parameters
INTEGER, PARAMETER :: n = 624, n1 = n+1, m = 397, mata = -1727483681
!                                    constant vector a
INTEGER, PARAMETER :: umask = -2147483647 - 1
!                                    most significant w-r bits
INTEGER, PARAMETER :: lmask =  2147483647
!                                    least significant r bits
! Tempering parameters
INTEGER, PARAMETER :: tmaskb= -1658038656, tmaskc= -272236544

!                     the array for the state vector
INTEGER, SAVE      :: mt(0:n-1), mti = n1
!                     mti==N+1 means mt[N] is not initialized

PRIVATE
PUBLIC :: dp, sgrnd, grnd, init_genrand

CONTAINS


SUBROUTINE sgrnd(seed)
! This is the original version of the seeding routine.
! It was replaced in the Japanese version in C on 26 January 2002
! It is recommended that routine init_genrand is used instead.

INTEGER, INTENT(IN)   :: seed

!    setting initial seeds to mt[N] using the generator Line 25 of Table 1 in
!    [KNUTH 1981, The Art of Computer Programming Vol. 2 (2nd Ed.), pp102]

mt(0)= IAND(seed, -1)
DO  mti=1,n-1
  mt(mti) = IAND(69069 * mt(mti-1), -1)
END DO

RETURN
END SUBROUTINE sgrnd
!***********************************************************************

SUBROUTINE init_genrand(seed)
! This initialization is based upon the multiplier given on p.106 of the
! 3rd edition of Knuth, The Art of Computer Programming Vol. 2.

! This version assumes that integer overflow does NOT cause a crash.

INTEGER, INTENT(IN)  :: seed

INTEGER  :: latest

mt(0) = seed
latest = seed
DO mti = 1, n-1
  latest = IEOR( latest, ISHFT( latest, -30 ) )
  latest = latest * 1812433253 + mti
  mt(mti) = latest
END DO

RETURN
END SUBROUTINE init_genrand
!***********************************************************************

FUNCTION grnd() RESULT(fn_val)
use qutraj_precision
REAL (dp) :: fn_val

INTEGER, SAVE :: mag01(0:1) = (/ 0, mata /)
!                        mag01(x) = x * MATA for x=0,1
INTEGER       :: kk, y

! These statement functions have been replaced with separate functions
! tshftu(y) = ISHFT(y,-11)
! tshfts(y) = ISHFT(y,7)
! tshftt(y) = ISHFT(y,15)
! tshftl(y) = ISHFT(y,-18)

IF(mti >= n) THEN
!                       generate N words at one time
  IF(mti == n+1) THEN
!                            if sgrnd() has not been called,
    CALL sgrnd(4357)
!                              a default initial seed is used
  END IF
  
  DO  kk = 0, n-m-1
    y = IOR(IAND(mt(kk),umask), IAND(mt(kk+1),lmask))
    mt(kk) = IEOR(IEOR(mt(kk+m), ISHFT(y,-1)),mag01(IAND(y,1)))
  END DO
  DO  kk = n-m, n-2
    y = IOR(IAND(mt(kk),umask), IAND(mt(kk+1),lmask))
    mt(kk) = IEOR(IEOR(mt(kk+(m-n)), ISHFT(y,-1)),mag01(IAND(y,1)))
  END DO
  y = IOR(IAND(mt(n-1),umask), IAND(mt(0),lmask))
  mt(n-1) = IEOR(IEOR(mt(m-1), ISHFT(y,-1)),mag01(IAND(y,1)))
  mti = 0
END IF

y = mt(mti)
mti = mti + 1
y = IEOR(y, tshftu(y))
y = IEOR(y, IAND(tshfts(y),tmaskb))
y = IEOR(y, IAND(tshftt(y),tmaskc))
y = IEOR(y, tshftl(y))

IF(y < 0) THEN
  fn_val = (DBLE(y) + 2.0D0**32) / (2.0D0**32 - 1.0D0)
ELSE
  fn_val = DBLE(y) / (2.0D0**32 - 1.0D0)
END IF

RETURN
END FUNCTION grnd


FUNCTION tshftu(y) RESULT(fn_val)
INTEGER, INTENT(IN) :: y
INTEGER             :: fn_val

fn_val = ISHFT(y,-11)
RETURN
END FUNCTION tshftu


FUNCTION tshfts(y) RESULT(fn_val)
INTEGER, INTENT(IN) :: y
INTEGER             :: fn_val

fn_val = ISHFT(y,7)
RETURN
END FUNCTION tshfts


FUNCTION tshftt(y) RESULT(fn_val)
INTEGER, INTENT(IN) :: y
INTEGER             :: fn_val

fn_val = ISHFT(y,15)
RETURN
END FUNCTION tshftt


FUNCTION tshftl(y) RESULT(fn_val)
INTEGER, INTENT(IN) :: y
INTEGER             :: fn_val

fn_val = ISHFT(y,-18)
RETURN
END FUNCTION tshftl

END MODULE mt19937



! this main() outputs the first 1000 generated numbers
PROGRAM main
USE mt19937
IMPLICIT NONE

INTEGER, PARAMETER :: no = 1000
INTEGER            :: count, j, k, seed
REAL (dp)          :: temp, r(0:7), big, small, average, sumsq, stdev

!      call sgrnd(4357)
!                         any nonzero integer can be used as a seed
WRITE(*, '(a)', ADVANCE='NO') ' Enter integer random number seed: '
READ(*, *) seed
CALL init_genrand(seed)
WRITE(*, *) 'Seed = ', seed

big = 0.5_dp
small = 0.5_dp
count = 0
average = 0.0_dp
sumsq = 0.0_dp

DO  j=0,no-1
  temp = grnd()
  IF (temp > big) THEN
    big = temp
  ELSE IF (temp < small) THEN
    small = temp
  END IF
  CALL update(temp, count, average, sumsq)
  r(MOD(j,8)) = temp
  IF(MOD(j,8) == 7) THEN
    WRITE(*, '(8(f8.6, '' ''))') r(0:7)
  ELSE IF(j == no-1) THEN
    WRITE(*, '(8(f8.6, '' ''))') (r(k),k=0,MOD(no-1,8))
  END IF
END DO

stdev = SQRT( sumsq / (count - 1) )
WRITE(*, '(a, f10.6, a, f10.6)') ' Smallest = ', small, '  Largest = ', big
WRITE(*, '(a, f9.5, a, f9.5)') ' Average = ', average, '  Std. devn. = ', stdev
WRITE(*, *) ' Std. devn. should be about 1/sqrt(12) = 0.288675'

STOP


CONTAINS


SUBROUTINE update(x, n, avge, sumsq)
REAL (dp), INTENT(IN)      :: x
INTEGER, INTENT(IN OUT)    :: n
REAL (dp), INTENT(IN OUT)  :: avge, sumsq

REAL (dp)  :: dev

n = n + 1
dev = x - avge
avge = avge + dev / n
sumsq = sumsq + dev*(x - avge)

RETURN
END SUBROUTINE update

END PROGRAM main
!***********************************************************************

module qutraj_general
  !
  ! Global constants and general purpose subroutines
  !

  use qutraj_precision

  implicit none

  !
  ! Constants
  !

  ! error params
  integer, parameter :: blas_error_param    = -23

  ! imaginary unit
  complex(wp), parameter :: ii = (0._wp,1._wp)

  !
  ! Interfaces
  !

  interface new
    module procedure int_array_init
    module procedure int_array_init2
    module procedure wp_array_init
    module procedure wp_array_init2
  end interface

  interface finalize
    module procedure int_array_finalize
    module procedure wp_array_finalize
  end interface

  contains

  !
  ! Initializers and finalizers
  !

  subroutine int_array_init(this,n)
    integer, allocatable, intent(inout) :: this(:)
    integer, intent(in) :: n
    integer :: istat
    if (allocated(this)) then
      deallocate(this,stat=istat)
    endif
    allocate(this(n),stat=istat)
    if (istat.ne.0) then
      call fatal_error("int_array_init: could not allocate.",istat)
    endif
  end subroutine

  subroutine int_array_init2(this,val)
    integer, allocatable, intent(inout) :: this(:)
    integer, intent(in), dimension(:) :: val
    call int_array_init(this,size(val))
    this = val
  end subroutine

  subroutine wp_array_init(this,n)
    real(wp), allocatable, intent(inout) :: this(:)
    integer, intent(in) :: n
    integer :: istat
    if (allocated(this)) then
      deallocate(this,stat=istat)
    endif
    allocate(this(n),stat=istat)
    if (istat.ne.0) then
      call fatal_error("sp_array_init: could not allocate.",istat)
    endif
  end subroutine

  subroutine wp_array_init2(this,val)
    real(wp), allocatable, intent(inout) :: this(:)
    real(wp), intent(in), dimension(:) :: val
    call wp_array_init(this,size(val))
    this = val
  end subroutine

  subroutine int_array_finalize(this)
    integer, allocatable, intent(inout) :: this(:)
    integer :: istat=0
    if (allocated(this)) then
      deallocate(this,stat=istat)
    endif
    if (istat.ne.0) then
      call error("int_array_finalize: could not deallocate.",istat)
    endif
  end subroutine

  subroutine wp_array_finalize(this)
    real(wp), allocatable, intent(inout) :: this(:)
    integer :: istat=0
    if (allocated(this)) then
      deallocate(this,stat=istat)
    endif
    if (istat.ne.0) then
      call error("wp_array_finalize: could not deallocate.",istat)
    endif
  end subroutine

  !
  ! Error handling
  !

  subroutine error(errormsg,ierror)
    character(len=*), intent(in), optional :: errormsg
    integer, intent(in), optional :: ierror
    if (present(errormsg)) then
      write(*,*) 'error: ',errormsg
    endif
    if (present(ierror)) then
      write(*,*) 'error flag=',ierror
    endif
  end subroutine

  subroutine fatal_error(errormsg,ierror)
    character(len=*), intent(in), optional :: errormsg
    integer, intent(in), optional :: ierror
    if (present(errormsg)) then
      write(*,*) 'fatal error: ',errormsg
    endif
    if (present(ierror)) then
      write(*,*) 'error flag=',ierror
    endif
    write(*,*) 'halting'
    stop 1
  end subroutine

end module

module qutraj_precision
  ! Module for setting working precision

  implicit none

  !integer, parameter :: sp = kind(1.0e0) ! single precision
  !integer, parameter :: dp = kind(1.0d0) ! double precision
  integer, parameter :: sp = selected_real_kind(6,37) ! single precision
  integer, parameter :: dp = selected_real_kind(15,307) ! double precision
  integer, parameter :: wp = dp ! working precision

  ! small and large number
  real, parameter :: epsi=5*epsilon(1.0)
  real, parameter :: huge1=0.2*huge(1.0)

end module

module qutraj_hilbert
  !
  ! Module implementing and providing abstraction of
  ! the Hilbert space
  !
  ! States are complex 1d arrays, and
  ! operators are CSR matrices
  !

  use qutraj_precision
  use qutraj_general

  implicit none

  !
  ! Types
  !

  type operat
    ! Operators are represented as spare matrices
    ! stored in compressed row format (CSR)

    ! m = number of rows, k = number of cols
    ! (should have m=k for operators!)
    integer :: m,k
    ! number of values
    integer :: nnz
    !! compression format is CSR
    !character*5 :: fida = 'CSR'
    !! base: Fortran or C base
    !integer :: base = 1 !
    !! diag: 'U' for un-stored diag entries, assumed to be one
    !character*11 :: diag = 'N'
    !! typem: 'S' for symmetric, 'H' for Hermitian
    !character*11 :: typem = 'G'
    !!both/lower/upper half of matrix specified
    !character*11 :: part = 'B'
    ! values
    complex(wp), allocatable :: a(:)
    integer, allocatable :: ia1(:),pb(:)!,pe(:)
    ! notice: pe(i) = pb(i+1)-1
  end type

  !
  ! Interfaces
  !

  interface new
    module procedure state_init
    module procedure state_init2_wp
    module procedure operat_init
    module procedure operat_init2_wp
    module procedure operat_list_init
  end interface

  interface finalize
    module procedure state_finalize
    module procedure operat_finalize
    module procedure operat_list_finalize
  end interface

  interface assignment(=)
    module procedure operat_operat_eq
  end interface

  interface operator(*)
    module procedure operat_state_mult
    module procedure real_operat_mult
    module procedure operat_operat_mult
  end interface

  interface operator(+)
    module procedure operat_operat_add
  end interface

  !
  ! Subs and funcs
  !

  contains

  !
  ! Initializers & finalizers
  !

  subroutine state_init(this,n)
    complex(wp), allocatable :: this(:)
    integer, intent(in) :: n
    integer :: istat=0
    if (allocated(this)) then
      deallocate(this,stat=istat)
    endif
    allocate(this(n),stat=istat)
    if (istat.ne.0) then
      call fatal_error("state_init: could not allocate.",istat)
    endif
  end subroutine

  subroutine state_init2_wp(this,val)
    complex(wp), allocatable :: this(:)
    complex(wp), intent(in) :: val(:)
    call state_init(this,size(val))
    this = val
  end subroutine

  subroutine state_finalize(this)
    complex(wp), allocatable :: this(:)
    integer :: istat=0
    if (allocated(this)) then
      deallocate(this,stat=istat)
    endif
    if (istat.ne.0) then
      call error("state_finalize: could not deallocate.",istat)
    endif
  end subroutine

  subroutine operat_init(this,nnz,nptr)
    ! todo: add special support for Hermitian matrix
    type(operat), intent(out) :: this
    integer, intent(in) :: nnz,nptr
    integer :: istat=0,nnz_,nptr_
    if (allocated(this%a)) then
      deallocate(this%a,stat=istat)
    endif
    if (allocated(this%ia1)) then
      deallocate(this%ia1,stat=istat)
    endif
    if (allocated(this%pb)) then
      deallocate(this%pb,stat=istat)
    endif
    nnz_ = nnz
    nptr_ = nptr
    if (nnz==0) nnz_= 1
    if (nptr==0) nptr_= 1
    this%nnz = nnz_
    allocate(this%a(nnz_),stat=istat)
    if (istat.ne.0) then
      call fatal_error("operat_init: could not allocate.",istat)
    endif
    allocate(this%ia1(nnz_),stat=istat)
    if (istat.ne.0) then
      call fatal_error("operat_init: could not allocate.",istat)
    endif
    allocate(this%pb(nptr_),stat=istat)
    if (istat.ne.0) then
      call fatal_error("operat_init: could not allocate.",istat)
    endif
    ! Set to zero
    this%a = (0.,0.)
    !this%ia1 = 1
    !this%pb = 1
    !this%m = 1
    !this%k = 1
    ! Set default parameters
    !this%fida = 'CSR'
    !this%base = 1 ! fortran base
    !this%diag = 'N'
    !this%typem = 'G'
    !this%part = 'B'
  end subroutine

  subroutine operat_init2_wp(this,val,col,ptr,m,k)
    integer, intent(in) :: m,k
    type(operat), intent(out) :: this
    complex(wp), intent(in) :: val(:)
    integer, intent(in) :: col(:),ptr(:)
    ! integer :: i
    if (size(val)==0) then
      call operat_init(this,1,1)
      this%m = 1
      this%k = 1
      this%a = (/(0.,0.)/)
      this%ia1 = (/1/)
      this%pb = (/1,2/)
    else
      call operat_init(this,size(val),size(ptr))
      this%m = m
      this%k = k
      this%a = val
      this%ia1 = col
      this%pb = ptr
    endif
  end subroutine

  subroutine operat_list_init(this,n)
    type(operat), intent(inout), allocatable :: this(:)
    integer, intent(in) :: n
    integer :: istat
    if (allocated(this)) then
      deallocate(this,stat=istat)
    endif
    allocate(this(n),stat=istat)
    if (istat.ne.0) then
      call fatal_error("operat_list_init: could not allocate.",istat)
    endif
  end subroutine

  subroutine operat_finalize(this)
    type(operat), intent(inout) :: this
    integer :: istat=0
    if (allocated(this%a)) then
      deallocate(this%a,stat=istat)
      if (istat.ne.0) then
        call error("operat_finalize: could not deallocate.",istat)
      endif
    endif
    if (allocated(this%ia1)) then
      deallocate(this%ia1,stat=istat)
      if (istat.ne.0) then
        call error("operat_finalize: could not deallocate.",istat)
      endif
    endif
    if (allocated(this%pb)) then
      deallocate(this%pb,stat=istat)
      if (istat.ne.0) then
        call error("operat_finalize: could not deallocate.",istat)
      endif
    endif
  end subroutine

  subroutine operat_list_finalize(this)
    type(operat), intent(inout), allocatable :: this(:)
    integer :: istat=0,i
    if (allocated(this)) then
      do i=1,size(this)
        call finalize(this(i))
      enddo
      deallocate(this,stat=istat)
    endif
    if (istat.ne.0) then
      call error("operat_list_finalize: could not deallocate.",istat)
    endif
  end subroutine

  !
  ! State/operator arithmetic
  !

  subroutine operat_operat_eq(this,a)
    type(operat), intent(out) :: this
    type(operat), intent(in) :: a
    call new(this,a%a,a%ia1,a%pb,a%m,a%k)
  end subroutine

  function operat_operat_add(a,b)
    type(operat) :: operat_operat_add
    type(operat), intent(in) :: a,b
    type(operat) :: c,d
    integer :: nzmax,ierr
    integer, allocatable :: iw(:)
    call new(iw,a%k)
    nzmax = size(a%a) + size(b%a)
    call new(c,nzmax,a%m+1)
    call aplb(a%m,a%k,1,a%a,a%ia1,a%pb,b%a,b%ia1,b%pb,c%a,c%ia1,c%pb,&
      nzmax,iw,ierr)
    if (ierr.ne.0) then
      call error('operat_operat_add',ierr)
    endif
    !call finalize(iw)
    nzmax = count(c%a.ne.0)
    c%pb(size(c%pb)) = nzmax+1
    call new(d,c%a(1:nzmax),c%ia1(1:nzmax),c%pb,a%m,b%k)
    operat_operat_add = d
  end function

  function operat_state_mult(oper,psi)
    complex(wp), intent(in) :: psi(:)
    type(operat), intent(in) :: oper
    complex(wp):: operat_state_mult(size(psi))
    complex(wp), allocatable :: tmp(:)
    integer :: ierr
    call new(tmp,size(psi))
    call sparse_mv_mult(oper,psi,tmp,ierr)
    if (ierr.ne.0) then
      call error("operate_state_mult: error",ierr)
    endif
    operat_state_mult = tmp
    call finalize(tmp)
  end function

  function real_operat_mult(r,a)
    type(operat) :: real_operat_mult
    real(wp), intent(in) :: r
    type(operat), intent(in) :: a
    type(operat) :: c
    call new(c,r*a%a,a%ia1,a%pb,a%m,a%k)
    real_operat_mult = c
  end function

  function operat_operat_mult(a,b)
    type(operat) :: operat_operat_mult
    type(operat), intent(in) :: a,b
    type(operat) :: c,d
    integer :: nzmax,ierr
    integer, allocatable :: iw(:)
    call new(iw,b%k)
    nzmax = a%nnz*b%nnz
    call new(c,nzmax,a%m+1)
    call amub(a%m,b%k,1,a%a,a%ia1,a%pb,b%a,b%ia1,b%pb,&
      c%a,c%ia1,c%pb,nzmax,iw,ierr)
    if (ierr.ne.0) call error('operat_operat_mult',ierr)
    !call finalize(iw)
    nzmax = count(c%a.ne.0)
    c%pb(size(c%pb)) = nzmax+1
    call new(d,c%a(1:nzmax),c%ia1(1:nzmax),c%pb,a%m,b%k)
    operat_operat_mult = d
  end function

  subroutine operat_operat_mult_sub(a,b,d)
    type(operat), intent(out) :: d
    type(operat), intent(in) :: a,b
    type(operat) :: c
    integer :: nzmax,ierr
    integer, allocatable :: iw(:)
    call new(iw,b%k)
    nzmax = a%nnz*b%nnz
    write(*,*) 'a%m',a%m,'a%k',a%k,'a%nnz',a%nnz
    write(*,*) 'b%m',b%m,'b%k',b%k,'b%nnz',b%nnz
    call new(c,nzmax,a%m+1)
    write(*,*) 'created c'
    call amub(a%m,b%k,1,a%a,a%ia1,a%pb,b%a,b%ia1,b%pb,&
      c%a,c%ia1,c%pb,nzmax,iw,ierr)
    if (ierr.ne.0) call error('operat_operat_mult',ierr)
    write(*,*) 'product'
    write(*,*) size(c%a),size(c%pb)
    !call finalize(iw)
    nzmax = count(c%a.ne.0)
    write(*,*) 'nzmax=',nzmax
    c%pb(size(c%pb)) = nzmax+1
    write(*,*) 'before d'
    call new(d,c%a(1:nzmax),c%ia1(1:nzmax),c%pb,a%m,b%k)
    !call finalize(c)
    write(*,*) 'd%m',d%m,'d%k',d%k,'d%nnz',d%nnz,size(d%a),size(d%pb)
    write(*,*) 'mult done'
  end subroutine

  function braket(fi,psi)
    ! return <fi|psi>
    complex(wp) :: braket
    complex(wp), intent(in) :: fi(:),psi(:)
    braket = sum(conjg(fi)*psi)
  end function

  subroutine normalize(psi)
    complex(wp), intent(inout) :: psi(:)
    real(wp) :: tmp
    tmp = sqrt(abs(braket(psi,psi)))
    ! Check for division by zero
    if (abs(tmp) < epsi) then
      psi = 0.
    else
      psi = psi/tmp
    end if
  end subroutine

  function ket_to_operat(psi)
    ! Turns a 1d complex array psi into derived type operat
    ! psi is interpreted as a column vector
    ! i.e. no of rows = size(psi), no of columns = 1
    type(operat) :: ket_to_operat
    complex(wp), intent(in) :: psi(:)
    type(operat) :: c,d
    integer :: nzmax,ierr
    nzmax = count(psi.ne.0)
    call new(c,nzmax,size(psi)+1)
    !state_to_operat = c
    call dnscsr(size(psi),1,nzmax,psi,size(psi),c%a,c%ia1,c%pb,ierr)
    !nzmax = count(abs(c%a).ge.epsi)
    call new(d,c%a,c%ia1,c%pb,size(psi),1)
    ket_to_operat = d
  end function

  function bra_to_operat(psi)
    ! Turns a 1d complex array psi into derived type operat
    ! psi is interpreted as a row vector
    ! i.e. no of rows = 1, no of columns = size(psi)
    type(operat) :: bra_to_operat
    complex(wp), intent(in) :: psi(:)
    type(operat) :: c,d
    integer :: nzmax,ierr
    nzmax = count(psi.ne.0)
    call new(c,nzmax,1+1)
    !state_to_operat = c
    call dnscsr(1,size(psi),nzmax,psi,1,c%a,c%ia1,c%pb,ierr)
    !nzmax = count(abs(c%a).ge.epsi)
    call new(d,c%a,c%ia1,c%pb,1,size(psi))
    bra_to_operat = d
  end function

  !
  ! Misc.
  !

  subroutine densitymatrix_dense(psi,rho)
    ! Dense density matrix from pure state
    complex(wp), intent(in) :: psi(:)
    complex(wp), intent(out) :: rho(:,:)
    complex(wp), allocatable :: tmp(:,:)
    integer istat
    allocate(tmp(1,size(psi)),stat=istat)
    tmp(1,:) = psi
    rho = matmul(transpose(conjg(tmp)),tmp)
  end subroutine

  subroutine densitymatrix_sparse(psi,rho)
    ! Sparse density matrix from pure state
    complex(wp), intent(in) :: psi(:)
    type(operat), intent(out) :: rho
    ! type(operat) :: a,b
    rho = ket_to_operat(psi)*bra_to_operat(conjg(psi))
  end subroutine

  subroutine ptrace_pure(psi,rho,sel,dims)
    ! Partial trace over pure state
    ! Under construction
    ! Currently only correct for sel = (/1,2,../)
    ! i.e. no permutations
    complex(wp), intent(in) :: psi(:)
    integer, intent(in) :: sel(:),dims(:)
    complex(wp), intent(out) :: rho(:,:)
    complex(wp), allocatable :: a(:,:)
    integer :: m,n,prod_dims_sel,prod_dims_rest
    integer :: i,j,istat
    logical :: insel

    m = 1
    n = 1
    prod_dims_sel = 1
    prod_dims_rest = 1
    do i=1,size(dims)
      n=n*dims(i)
      insel = .false.
      do j=1,size(sel)
        if (i==sel(j)) then
          m=m*dims(i)
          prod_dims_sel = prod_dims_sel*dims(i)
          insel=.true.
        endif
      enddo
      if (.not.insel) then
        prod_dims_rest = prod_dims_rest*dims(i)
      endif
    enddo
    allocate(a(prod_dims_rest,prod_dims_sel),stat=istat)
    a = reshape(psi,(/prod_dims_rest,prod_dims_sel/))
    !allocate(rho(prod_dims_sel,prod_dims_sel),stat=istat)
    rho = matmul(transpose(conjg(a)),a)
  end subroutine

  !
  ! Sparse matrix routines
  !

  subroutine sparse_mv_mult(mat,x,y,ierr)
    ! y = Ax
    ! Adapted from sparse blas
    type(operat) :: mat
    complex(KIND=wp) , dimension(:), intent(in) :: x
    complex(KIND=wp) , dimension(:), intent(out) :: y
    integer, intent(out) :: ierr
    integer :: m,n,ofs,i,pntr
    ! integer :: base
    ! character :: diag,type,part
    ierr = -1
    m = size(y)
    n = size(x)
    !if ((mat%FIDA.ne.'CSR').or.(mat%M.ne.m).or.(mat%K.ne.n)) then
    !   ierr = blas_error_param
    !   return
    !end if
    !base = mat%base
    !ofs = 1 - base
    !diag = mat%diag
    !type = mat%typem
    !part = mat%part
    ofs = 0
    y = (0.0d0, 0.0d0) 
    !if (diag.eq.'U') then !process unstored diagonal
    !   if (m.eq.n) then
    !      y = x
    !   else
    !      ierr = blas_error_param
    !      return
    !   end if
    !end if
    !if ((type.eq.'S').and.(.not.(part.eq.'B')).and.(m.eq.n)) then 
    !   if (part.eq.'U') then
    !      do i = 1, mat%M
    !         pntr = mat%pb(i)
    !         do while(pntr.lt.mat%pe(i))
    !            if(i.eq.mat%IA1(pntr + ofs) + ofs) then
    !               y(i) = y(i) &
    !            + mat%A(pntr + ofs) * x(mat%IA1(pntr + ofs ) + ofs) 
    !            else if (i.lt.mat%IA1(pntr + ofs) + ofs) then
    !               y(i) = y(i) &
    !            + mat%A(pntr + ofs) * x(mat%IA1(pntr + ofs ) + ofs) 
    !               y(mat%IA1(pntr + ofs) + ofs) =  &
    !        y(mat%IA1(pntr + ofs ) + ofs) + mat%A(pntr + ofs) * x(i) 
    !            end if
    !            pntr = pntr + 1
    !         end do
    !      end do
    !   else
    !      do i = 1, mat%M
    !         pntr = mat%pb(i)
    !         do while(pntr.lt.mat%pe(i))
    !            if(i.eq.mat%IA1(pntr + ofs) + ofs) then
    !               y(i) = y(i) &
    !            + mat%A(pntr + ofs) * x(mat%IA1(pntr + ofs ) + ofs) 
    !            else if (i.gt.mat%IA1(pntr + ofs) + ofs) then
    !               y(i) = y(i) &
    !            + mat%A(pntr + ofs) * x(mat%IA1(pntr + ofs ) + ofs) 
    !               y(mat%IA1(pntr + ofs) + ofs) = &
    !        y(mat%IA1(pntr + ofs ) + ofs) + mat%A(pntr + ofs) * x(i) 
    !            end if
    !            pntr = pntr + 1
    !         end do
    !      end do
    !   end if
    !   ierr = 0
    !else if((type.eq.'H').and.(.not.(part.eq.'B')).and.(m.eq.n)) then 
    !   if (part.eq.'U') then
    !      do i = 1, mat%M
    !         pntr = mat%pb(i)
    !         do while(pntr.lt.mat%pe(i))
    !            if(i.eq.mat%IA1(pntr + ofs) + ofs) then
    !               y(i) = y(i) &
    !            + mat%A(pntr + ofs) * x(mat%IA1(pntr + ofs ) + ofs) 
    !            else if (i.lt.mat%IA1(pntr + ofs) + ofs) then
    !               y(i) = y(i) &
    !            + mat%A(pntr + ofs) * x(mat%IA1(pntr + ofs ) + ofs) 
    !              y(mat%IA1(pntr+ofs)+ofs)=y(mat%IA1(pntr+ofs)+ofs) &
    !                     + conjg (mat%A(pntr + ofs)) * x(i) 
    !            end if
    !            pntr = pntr + 1
    !         end do
    !      end do
    !   else
    !      do i = 1, mat%M
    !         pntr = mat%pb(i)
    !         do while(pntr.lt.mat%pe(i))
    !            if(i.eq.mat%IA1(pntr + ofs) + ofs) then
    !               y(i) = y(i) &
    !            + mat%A(pntr + ofs) * x(mat%IA1(pntr + ofs ) + ofs) 
    !            else if (i.gt.mat%IA1(pntr + ofs) + ofs) then
    !               y(i) = y(i) &
    !            + mat%A(pntr + ofs) * x(mat%IA1(pntr + ofs ) + ofs) 
    !             y(mat%IA1(pntr+ofs)+ofs)=y(mat%IA1(pntr+ofs)+ofs) &
    !                     + conjg (mat%A(pntr + ofs)) * x(i) 
    !            end if
    !            pntr = pntr + 1
    !         end do
    !      end do
    !   end if
    !   ierr = 0
    !else
       do i = 1, mat%M
          pntr = mat%pb(i)
          !do while(pntr.lt.mat%pe(i))
          do while(pntr.lt.mat%pb(i+1))
            y(i) = y(i) &
                + mat%A(pntr + ofs) * x(mat%IA1(pntr + ofs ) + ofs) 
             pntr = pntr + 1
          end do
       end do
       ierr = 0
    !end if
  end subroutine


!  subroutine amux ( n, x, y, a, ja, ia )
!  ! Aadapted from sparsekit
!
!  !*****************************************************************************80
!  !
!  !! AMUX multiplies a CSR matrix A times a vector.
!  !
!  !  Discussion:
!  !
!  !    This routine multiplies a matrix by a vector using the dot product form.
!  !    Matrix A is stored in compressed sparse row storage.
!  !
!  !  Modified:
!  !
!  !    07 January 2004
!  !
!  !  Author:
!  !
!  !    Youcef Saad
!  !
!  !  Parameters:
!  !
!  !    Input, integer N, the row dimension of the matrix.
!  !
!  !    Input, real X(*), and array of length equal to the column dimension 
!  !    of A.
!  !
!  !    Input, real A(*), integer JA(*), IA(NROW+1), the matrix in CSR
!  !    Compressed Sparse Row format.
!  !
!  !    Output, real Y(N), the product A * X.
!  !
!    implicit none
!
!    integer n
!
!    complex ( kind = wp ) a(*)
!    integer i
!    integer ia(*)
!    integer ja(*)
!    integer k
!    complex ( kind = wp ) t
!    complex ( kind = wp ) x(*)
!    complex ( kind = wp ) y(n)
!
!    do i = 1, n
!  !
!  !  Compute the inner product of row I with vector X.
!  !
!      t = (0.0,0.0)
!      do k = ia(i), ia(i+1)-1
!        t = t + a(k) * x(ja(k))
!      end do
!
!      y(i) = t
!
!    end do
!
!    return
!  end
!

subroutine aplb ( nrow, ncol, job, a, ja, ia, b, jb, ib, c, jc, ic, nzmax, &
  iw, ierr )

! Adapted from sparsekit

!*****************************************************************************80
!
!! APLB performs the CSR matrix sum C = A + B.
!
!  Modified:
!
!    07 January 2004
!
!  Author:
!
!    Youcef Saad
!
!  Parameters:
!
!    Input, integer NROW, the row dimension of A and B.
!
!    Input, integer NCOL, the column dimension of A and B.
!
!    Input, integer JOB.  When JOB = 0, only the structure
!    (i.e. the arrays jc, ic) is computed and the
!    real values are ignored.
!
!    Input, real A(*), integer JA(*), IA(NROW+1), the matrix in CSR
!    Compressed Sparse Row format.
!
! b,
! jb,
! ib      =  Matrix B in compressed sparse row format.
!
! nzmax      = integer. The  length of the arrays c and jc.
!         amub will stop if the result matrix C  has a number
!         of elements that exceeds exceeds nzmax. See ierr.
!
! on return:
!
! c,
! jc,
! ic      = resulting matrix C in compressed sparse row sparse format.
!
! ierr      = integer. serving as error message.
!         ierr = 0 means normal return,
!         ierr > 0 means that amub stopped while computing the
!         i-th row  of C with i = ierr, because the number
!         of elements in C exceeds nzmax.
!
! work arrays:
!
! iw      = integer work array of length equal to the number of
!         columns in A.
!
  implicit none

  integer ncol
  integer nrow

  complex ( kind = wp ) a(*)
  complex ( kind = wp ) b(*)
  complex ( kind = wp ) c(*)
  integer ia(nrow+1)
  integer ib(nrow+1)
  integer ic(nrow+1)
  integer ierr
  integer ii
  integer iw(ncol)
  integer ja(*)
  integer jb(*)
  integer jc(*)
  integer jcol
  integer job
  integer jpos
  integer k
  integer ka
  integer kb
  integer len
  integer nzmax
  logical values

  values = ( job /= 0 )
  ierr = 0
  len = 0
  ic(1) = 1
  iw(1:ncol) = 0

  do ii = 1, nrow
!
!  Row I.
!
     do ka = ia(ii), ia(ii+1)-1

        len = len + 1
        jcol = ja(ka)

        if ( nzmax < len ) then
          ierr = ii
          return
        end if

        jc(len) = jcol
        if ( values ) then
          c(len) = a(ka)
        end if
        iw(jcol) = len
     end do

     do kb = ib(ii), ib(ii+1)-1

        jcol = jb(kb)
        jpos = iw(jcol)

        if ( jpos == 0 ) then

           len = len + 1

           if ( nzmax < len ) then
             ierr = ii
             return
           end if

           jc(len) = jcol
           if ( values ) then
             c(len) = b(kb)
           end if
           iw(jcol)= len
        else
           if ( values ) then
             c(jpos) = c(jpos) + b(kb)
           end if
        end if

     end do

     do k = ic(ii), len
       iw(jc(k)) = 0
     end do

     ic(ii+1) = len+1
  end do

  return
end subroutine
subroutine amub ( nrow, ncol, job, a, ja, ia, b, jb, ib, c, jc, ic, nzmax, &
  iw, ierr )
  ! Aadapted from sparsekit

!*****************************************************************************80
!
!! AMUB performs the matrix product C = A * B.
!
!  Discussion:
!
!    The column dimension of B is not needed.
!
!  Modified:
!
!    08 January 2004
!
!  Author:
!
!    Youcef Saad
!
!  Parameters:
!
!    Input, integer NROW, the row dimension of the matrix.
!
!    Input, integer NCOL, the column dimension of the matrix.
!
!    Input, integer JOB, job indicator.  When JOB = 0, only the structure
!    is computed, that is, the arrays JC and IC, but the real values
!    are ignored.
!
!    Input, real A(*), integer JA(*), IA(NROW+1), the matrix in CSR
!    Compressed Sparse Row format.
!
!    Input, b, jb, ib, matrix B in compressed sparse row format.
!
!    Input, integer NZMAX, the length of the arrays c and jc.
!    The routine will stop if the result matrix C  has a number
!    of elements that exceeds exceeds NZMAX.
!
! on return:
!
! c,
! jc,
! ic    = resulting matrix C in compressed sparse row sparse format.
!
! ierr      = integer. serving as error message.
!         ierr = 0 means normal return,
!         ierr > 0 means that amub stopped while computing the
!         i-th row  of C with i = ierr, because the number
!         of elements in C exceeds nzmax.
!
! work arrays:
!
!  iw      = integer work array of length equal to the number of
!         columns in A.
!
  implicit none

  integer ncol
  integer nrow
  integer nzmax

  complex ( kind = wp ) a(*)
  complex ( kind = wp ) b(*)
  complex ( kind = wp ) c(nzmax)
  integer ia(nrow+1)
  integer ib(ncol+1)
  integer ic(ncol+1)
  integer ierr
  integer ii
  integer iw(ncol)
  integer ja(*)
  integer jb(*)
  integer jc(nzmax)
  integer jcol
  integer jj
  integer job
  integer jpos
  integer k
  integer ka
  integer kb
  integer len
  complex ( kind = wp ) scal
  logical values

  values = ( job /= 0 )
  len = 0
  ic(1) = 1
  ierr = 0
!
!  Initialize IW.
!
  iw(1:ncol) = 0

  do ii = 1, nrow
!
!  Row I.
!
    do ka = ia(ii), ia(ii+1)-1

      if ( values ) then
        scal = a(ka)
      end if

      jj = ja(ka)

      do kb = ib(jj), ib(jj+1)-1

           jcol = jb(kb)
           jpos = iw(jcol)

           if ( jpos == 0 ) then
              len = len + 1
              if ( nzmax < len ) then
                 ierr = ii
                 return
              end if
              jc(len) = jcol
              iw(jcol)= len
              if ( values ) then
                c(len) = scal * b(kb)
              end if
           else
              if ( values ) then
                c(jpos) = c(jpos) + scal * b(kb)
              end if
           end if

         end do

    end do

    do k = ic(ii), len
      iw(jc(k)) = 0
    end do

    ic(ii+1) = len + 1

  end do

  return
end subroutine


subroutine dnscsr ( nrow, ncol, nzmax, dns, ndns, a, ja, ia, ierr )

! Adapted from Sparsekit

!*****************************************************************************80
!
!! DNSCSR converts Dense to Compressed Row Sparse format.
!
!  Discussion:
!
!    This routine converts a densely stored matrix into a row orientied
!    compactly sparse matrix.  It is the reverse of CSRDNS.
!
!    This routine does not check whether an element is small.  It considers 
!    that A(I,J) is zero only if it is exactly equal to zero.
!
!  Modified:
!
!    07 January 2004
!
!  Author:
!
!    Youcef Saad
!
!  Parameters:
!
!    Input, integer NROW, the row dimension of the matrix.
!
!    Input, integer NCOL, the column dimension of the matrix.
!
!    Input, integer NZMAX, the maximum number of nonzero elements 
!    allowed.  This should be set to be the lengths of the arrays A and JA.
!
!    Input, real DNS(NDNS,NCOL), an NROW by NCOL dense matrix.
!
!    Input, integer NDNS, the first dimension of DNS, which must be
!    at least NROW.
!
!    Output, real A(*), integer JA(*), IA(NROW+1), the matrix in CSR
!    Compressed Sparse Row format.
!
!    Output, integer IERR, error indicator.
!    0 means normal return;
!    I, means that the the code stopped while processing row I, because
!       there was no space left in A and JA, as defined by NZMAX.
!
  implicit none

  integer ncol
  integer ndns
  integer nrow

  complex ( kind = wp ) a(*)
  complex ( kind = wp ) dns(ndns,ncol)
  integer i
  integer ia(nrow+1)
  integer ierr
  integer j
  integer ja(*)
  integer next
  integer nzmax

  ierr = 0
  next = 1
  ia(1) = 1

  do i = 1, nrow

    do j = 1, ncol

      if ( dns(i,j) /= 0.0D+00 ) then

        if ( nzmax < next ) then
          ierr = i
          return
        end if

        ja(next) = j
        a(next) = dns(i,j)
        next = next + 1

      end if

    end do

    ia(i+1) = next

  end do

  return
end subroutine

end module

module qutraj_evolve
  use qutraj_precision
  use qutraj_general
  use qutraj_hilbert
  use linked_list
  use mt19937

  implicit none

  !
  ! Types
  !

  type options
    ! No. of ODES
    integer :: neq=1
    ! work array zwork should have length 15*neq for non-stiff
    integer :: lzw = 0
    double complex, allocatable :: zwork(:)
    ! work array rwork should have length 20+neq for non-siff
    integer :: lrw = 0
    double precision, allocatable :: rwork(:)
    ! work array iwork should have length 30 for non-stiff
    integer :: liw = 0
    integer, allocatable :: iwork(:)
    ! method flag mf should be 10 for non-stiff
    integer :: mf = 10
    ! arbitrary real/complex and int array for user def input to rhs
    double complex :: rpar(1)
    integer :: ipar(1)
    ! abs. tolerance, rel. tolerance 
    double precision, allocatable :: atol(:), rtol(:)
    ! iopt=number of optional inputs, itol=1 for atol scalar, 2 otherwise
    integer :: iopt, itol
    ! task and state of solver
    integer :: itask, istate
    ! tolerance for trying to find correct jump times
    integer :: norm_steps = 5
    real(wp) :: norm_tol = 0.001
  end type

  !
  ! Public data
  !

  type(operat) :: hamilt
  type(operat), allocatable :: c_ops(:), e_ops(:)
  type(options) :: ode

  ! Hermitian conjugated operators
  type(operat), allocatable :: c_ops_hc(:)

  contains

  !
  ! Evolution subs
  !

  subroutine evolve_nocollapse(t,tout,y,y_tmp,ode)
    double complex, intent(inout) :: y(:),y_tmp(:)
    double precision, intent(inout) :: t, tout
    type(options) :: ode

    ! integrate up to tout without overshooting
    ode%rwork(1) = tout

    call nojump(y,t,tout,ode%itask,ode)
    if (ode%istate.lt.0) then
      write(*,*) "zvode error: istate=",ode%istate
      !stop
    endif
  end subroutine

  subroutine evolve_jump(t,tout,y,y_tmp,p,mu,nu,&
    ll_col_times,ll_col_which,ode)
    !
    ! Evolve quantum trajectory y(t) to y(tout) using ``jump'' method
    !
    ! Input: t, tout, y
    ! Work arrays: y_tmp, p
    ! mu, nu: two random numbers
    !
    double complex, intent(inout) :: y(:),y_tmp(:)
    double precision, intent(inout) :: t, tout
    real(wp), intent(inout) :: p(:)
    real(wp), intent(inout) :: mu,nu
    type(linkedlist_real), intent(inout) :: ll_col_times
    type(linkedlist_int), intent(inout) :: ll_col_which
    type(options) :: ode
    double precision :: t_prev, t_final, t_guess
    integer :: j,k
    integer :: cnt
    real(wp) :: norm2_psi,norm2_prev,norm2_guess,sump
    ! logical, save :: first = .true.

    ode%rwork(1) = tout
    norm2_psi = abs(braket(y,y))
    do while(t<tout)
      t_prev = t
      y_tmp = y
      norm2_prev = norm2_psi
      call nojump(y,t,tout,ode%itask,ode)
      if (ode%istate.lt.0) then
        write(*,*) "zvode error: istate=",ode%istate
        !stop
      endif
      ! prob of nojump
      norm2_psi = abs(braket(y,y))
      if (norm2_psi.le.mu) then
        ! jump happened
        ! find collapse time to specified tolerance
        t_final = t
        cnt=1
        do k=1,ode%norm_steps
          !t_guess=t_prev+(mu-norm2_prev)&
          !  /(norm2_psi-norm2_prev)*(t_final-t_prev)
          t_guess=t_prev+log(norm2_prev/mu)&
            /log(norm2_prev/norm2_psi)*(t_final-t_prev)
          if (t_guess<t_prev .or. t_guess>t_final) then
            t_guess = t_prev+0.5*(t_final-t_prev)
          endif
          y = y_tmp
          t = t_prev
          call nojump(y,t,t_guess,1,ode)
          if (ode%istate.lt.0) then
            write(*,*) "zvode failed after adjusting step size. istate=",ode%istate
            !stop
          endif
          norm2_guess = abs(braket(y,y))
          if (abs(mu-norm2_guess) < ode%norm_tol*mu) then
              exit
          elseif (norm2_guess < mu) then
              ! t_guess is still > t_jump
              t_final=t_guess
              norm2_psi=norm2_guess
          else
              ! t_guess < t_jump
              t_prev=t_guess
              y_tmp=y
              norm2_prev=norm2_guess
          endif
          cnt = cnt+1
        enddo
        if (cnt > ode%norm_steps) then
          call error("Norm tolerance not reached. Increase accuracy of ODE solver or norm_steps.")
        endif
        ! determine which jump
        do j=1,size(c_ops)
          y_tmp = c_ops(j)*y
          p(j) = abs(braket(y_tmp,y_tmp))
        enddo
        p = p/sum(p)
        sump = 0
        do j=1,size(c_ops)
          if ((sump <= nu) .and. (nu < sump+p(j))) then
            y = c_ops(j)*y
            ! Append collapse time and operator # to linked lists
            call append(ll_col_times,t)
            call append(ll_col_which,j)
          endif
          sump = sump+p(j)
        enddo
        ! new random numbers
        mu = grnd()
        nu = grnd()
        ! normalize y
        call normalize(y)
        ! reset, first call to zvode
        ode%istate = 1
      endif
    enddo
  end subroutine

  subroutine nojump(y,t,tout,itask,ode)
    ! evolve with effective hamiltonian
    type(options), intent(in) :: ode
    double complex, intent(inout) :: y(:)
    double precision, intent(inout) :: t
    double precision, intent(in) :: tout
    integer, intent(in) :: itask
    !integer :: istat

    call zvode(rhs,ode%neq,y,t,tout,ode%itol,ode%rtol,ode%atol,&
      itask,ode%istate,ode%iopt,ode%zwork,ode%lzw,ode%rwork,ode%lrw,&
      ode%iwork,ode%liw,dummy_jac,ode%mf,ode%rpar,ode%ipar)
  end subroutine

  !
  ! RHS for zvode
  !

  subroutine rhs (neq, t, y, ydot, rpar, ipar)
    ! evolve with effective hamiltonian
    complex(wp) :: y(neq), ydot(neq),rpar
    real(wp) :: t
    integer :: ipar,neq
    ydot = (hamilt*y)
  end subroutine

  subroutine dummy_jac (neq, t, y, ml, mu, pd, nrpd, rpar, ipar)
    ! dummy jacobian for zvode
    complex(wp) :: y(neq), pd(nrpd,neq), rpar
    real(wp) :: t
    integer :: neq,ml,mu,nrpd,ipar
    return
  end subroutine

  !
  ! Diffusive unravelling evolution
  !

  !subroutine evolve_platen(psi,delta_t)
  !  ! TODO: Clean up use of temporary state vectors
  !  ! Diffusive solution, Platen scheme
  !  ! Evolve for a small time step delta_t
  !  ! State, inout, normalized
  !  complex(wp), intent(inout) :: psi(:)
  !  real(wp), intent(in) :: delta_t
  !  real(wp) :: p1,p2,pnj,dw
  !  integer :: i,j
  !  complex(wp), allocatable :: psi_n,dpsi1,dpsi2
  !  complex(wp), allocatable :: psi_tilde,psi_plus,psi_min

  !  call new(psi_n,size(psi))
  !  call new(dpsi1,size(psi))
  !  call new(dpsi2,size(psi))
  !  call new(psi_tilde,size(psi))
  !  call new(psi_plus,size(psi))
  !  call new(psi_min,size(psi))

  !  psi_n = psi

  !  ! Hamiltonian term
  !  !call hamiltonian(hamiltonian_id,psi,dpsi1)
  !  dpsi1 = -ii*(hamilt*psi)
  !  psi_tilde = psi + delta_t*dpsi1
  !  psi_n = psi_n + 0.5*delta_t*dpsi1
  !  !call hamiltonian(hamiltonian_id,psi_tilde,dpsi1)
  !  dpsi1 = (-ii)*(hamilt*psi_tilde)
  !  psi_n = psi_n + 0.5*delta_t*dpsi1

  !  do j=1,n_c_ops
  !    call schrod_d1_bp(j,psi,dpsi1)
  !    call schrod_d2_bp(j,psi,dpsi2)

  !    dw = sqrt(delta_t)*gaussran(rngseed,rngseed)
  !    psi_tilde = psi + delta_t*dpsi1 + dw*dpsi2
  !    psi_plus = psi + delta_t*dpsi1 + sqrt(delta_t)*dpsi2
  !    psi_min = psi + delta_t*dpsi1 - sqrt(delta_t)*dpsi2

  !    psi_n = psi_n + delta_t/2.0*dpsi1
  !    psi_n = psi_n + dw/2.0*dpsi2

  !    call schrod_d1_bp(j,psi_tilde,dpsi1)
  !    psi_n = psi_n + 0.5*delta_t*dpsi1
  !    call schrod_d2_bp(j,psi_plus,dpsi2)
  !    psi_n = psi_n + (dw + (dw*dw-delta_t)/sqrt(delta_t))/4.0*dpsi2
  !    call schrod_d2_bp(j,psi_min,dpsi2)
  !    psi_n = psi_n + (dw - (dw*dw-delta_t)/sqrt(delta_t))/4.0*dpsi2
  !  enddo
  !  call normalize(psi_n)
  !  psi = psi_n
  !end subroutine

  !subroutine d1_bp(i,psi,dpsi)
  !  ! D1 term from Breuer & Pettruccione
  !  ! Return D1 |Psi(t)> in dpsi, for jump-operator c_ops(i)
  !  ! B&P p. 331 eq (6.181)
  !  complex(wp), intent(in) :: psi(:)
  !  complex(wp), intent(out) :: dpsi(:)
  !  !complex(wp), allocatable :: psi_tmp(:)
  !  integer, intent(in) :: i
  !  complex(wp) :: tmp1, tmp2
  !  !call new(psi_tmp,size(psi))
  !  tmp1 = braket(psi,c_ops(i)*psi)
  !  tmp2 = braket(psi,c_ops(i)*psi)
  !  dpsi = 0.5_wp*(tmp1+tmp2)*(c_ops(i)*psi)
  !  dpsi = dpsi-(0.5_wp)*(c_ops_hc(i)*(c_ops(i)*psi))
  !  dpsi = dpsi-(0.125_wp*(tmp1+tmp2)*(tmp1+tmp2))*psi
  !end subroutine

  !subroutine d2_bp(i,psi,dpsi)
  !  ! D2 term from Breuer & Pettruccione
  !  ! Return D2 |Psi(t)> in dpsi, for jump-operator c_ops(i)
  !  ! B&P p. 331 eq (6.181)
  !  complex(wp), intent(in) :: psi(:)
  !  complex(wp), intent(out) :: dpsi(:)
  !  integer, intent(in) :: i
  !  complex(wp) :: tmp1, tmp2
  !  tmp1 = braket(psi,c_ops(i)*psi)
  !  tmp2 = braket(psi,c_ops_hc(i)*psi)
  !  dpsi = c_ops(i)*psi
  !  dpsi = dpsi - (0.5_wp*(tmp1+tmp2))*psi
  !end subroutine

end module

!
! TODO:
!

module qutraj_run
  !
  ! This is the main module on the fortran side of things
  !

  use qutraj_precision
  use qutraj_general
  use qutraj_hilbert
  use qutraj_evolve
  use qutraj_linalg
  use mt19937
  use linked_list

  implicit none

  !
  ! Data defining the problem
  !
  ! Invisible to python: hamilt, c_ops, e_opts, ode
  ! (because f2py can't handle derived types)
  !

  !type(operat) :: hamilt
  !type(operat), allocatable :: c_ops(:), e_ops(:)
  !type(options) :: ode

  real(wp), allocatable :: tlist(:)
  complex(wp), allocatable :: psi0(:)

  integer :: ntraj=1
  !integer :: norm_steps = 5
  !real(wp) :: norm_tol = 0.001
  integer :: n_c_ops = 0
  integer :: n_e_ops = 0
  logical :: average_states = .true.
  logical :: average_expect = .true.

  ! Optional ode options, 0 means use default values
  integer :: order=0,nsteps=0
  double precision :: first_step=0,min_step=0,max_step=0

  ! Solution
  ! format:
  ! all states: sol(1,trajectory,time,y(:))
  ! all expect: sol(e_ops(i),trajectory,time,expecation value)
  ! avg. expect: sol(e_ops(i),1,time,expectation value)
  ! if returning averaged dense density matrices:
  ! sol(1,time,rho_i,rho_j)
  complex(wp), allocatable :: sol(:,:,:,:)
  ! if returning averaged density matrices in sparse CSR format,
  ! use the following solution array and get_rho_sparse instead.
  type(operat), allocatable :: sol_rho(:)

  ! use sparse density matrices during computation?
  logical :: rho_return_sparse = .true.

  ! temporary storage for csr matrix, available for python
  ! this is needed because you can't send assumed
  ! shape arrays to python
  complex(wp), allocatable :: csr_val(:)
  integer, allocatable :: csr_col(:), csr_ptr(:)
  integer :: csr_nrows,csr_ncols

  ! Collapse times and integer denoting which operator did it
  ! temporary storage available for python
  real(wp), allocatable :: col_times(:)
  integer, allocatable :: col_which(:)
  ! data stored internally in linked lists, one per trajectory
  type(linkedlist_real), allocatable :: ll_col_times(:)
  type(linkedlist_int), allocatable :: ll_col_which(:)

  ! Integer denoting the type of unravelling
  ! 1 for no collapse operatros
  ! 2 for jump unravelling
  ! diffusive unravellings to be implemented
  integer :: unravel_type = 2

  ! Stuff needed for partial trace
  integer, allocatable :: psi0_dims1(:),ptrace_sel(:)
  integer :: rho_reduced_dim=0
  ! Calculate average entropy of reduced state over trajectories?
  logical :: calc_entropy = .false.
  real(wp), allocatable :: reduced_state_entropy(:)

  !
  ! Interfaces
  !

  interface finalize
    module procedure options_finalize
  end interface

  contains

  !
  ! Initialize problem
  !

  subroutine init_tlist(val,n)
    use qutraj_precision
    real(wp), intent(in) :: val(n)
    integer, intent(in) :: n
    call new(tlist,val)
  end subroutine

  subroutine init_psi0(val,n)
    use qutraj_precision
    complex(wp), intent(in) :: val(n)
    integer, intent(in) :: n
    call new(psi0,val)
  end subroutine

  subroutine init_ptrace_stuff(dims,sel,reduced_dim,ndims,nsel)
    integer, intent(in) :: dims(ndims),sel(nsel),reduced_dim
    integer, intent(in) :: ndims, nsel
    !complex(wp), allocatable :: rho(:,:)
    !real(wp) :: S
    call new(psi0_dims1,dims)
    call new(ptrace_sel,sel)
    rho_reduced_dim = reduced_dim
    !allocate(rho(rho_reduced_dim,rho_reduced_dim))
    !call ptrace_pure(psi0,rho,ptrace_sel,psi0_dims1)
    !write(*,*) rho
    !call entropy(rho,S)
    !write(*,*) S
  end subroutine

  subroutine init_hamiltonian(val,col,ptr,m,k,nnz,nptr)
    ! Hamiltonian is assumed to be given as
    ! -i*(H - i/2 sum c_ops(i)^* c_ops(i))
    use qutraj_precision
    integer, intent(in) :: nnz,nptr,m,k
    complex(wp), intent(in)  :: val(nnz)
    integer, intent(in) :: col(nnz),ptr(nptr)
    call new(hamilt,val,col,ptr,m,k)
  end subroutine

  subroutine init_c_ops(i,n,val,col,ptr,m,k,first,nnz,nptr)
    use qutraj_precision
    integer, intent(in) :: i,n
    integer, intent(in) :: nnz,nptr,m,k
    complex(wp), intent(in) :: val(nnz)
    integer, intent(in) :: col(nnz),ptr(nptr)
    logical, optional :: first
    if (.not.present(first)) then
      first = .false.
    endif
    if (first) then
      call new(c_ops,n)
    endif
    if (.not.allocated(c_ops)) then
      call error('init_c_ops: c_ops not allocated. call with first=True first.')
    endif
    n_c_ops = n
    call new(c_ops(i),val,col,ptr,m,k)
  end subroutine

  subroutine init_e_ops(i,n,val,col,ptr,m,k,first,nnz,nptr)
    use qutraj_precision
    integer, intent(in) :: i,n
    integer, intent(in) :: nnz,nptr,m,k
    complex(wp), intent(in) :: val(nnz)
    integer, intent(in) :: col(nnz),ptr(nptr)
    logical, optional :: first
    if (.not.present(first)) then
      first = .false.
    endif
    if (first) then
      call new(e_ops,n)
    endif
    if (.not.allocated(e_ops)) then
      call error('init_e_ops: e_ops not allocated. call with first=True first.')
    endif
    n_e_ops = n
    call new(e_ops(i),val,col,ptr,m,k)
  end subroutine

  subroutine init_result(neq,atol,rtol,mf,norm_steps,norm_tol,&
      lzw,lrw,liw,ml,mu,natol,nrtol)
    use qutraj_precision
    integer, intent(in) :: neq
    integer, intent(in), optional :: lzw,lrw,liw,mf,norm_steps
    integer, intent(in) :: natol,nrtol
    double precision, optional :: atol(1),rtol(1)
    real(wp), optional :: norm_tol
    integer, intent(in), optional :: ml,mu
    !integer :: istat

    ode%neq = neq
    if (lzw.ne.0) then
      ode%lzw = lzw
    endif
    if (lrw.ne.0) then
      ode%lrw = lrw
    endif
    if (liw.ne.0) then
      ode%liw = liw
    endif
    if (lrw.eq.0) then
      ode%lrw = 20+neq
    endif

    if (mf==0 .or. mf==10) then
      ! assuming non-stiff by default
      ode%mf=10
      if (lzw.eq.0) then
        ode%lzw = 15*neq
      endif
      if (liw.eq.0) then
        ode%liw = 30
      endif
    elseif (mf==21.or.mf==22) then
      ode%mf = mf
      if (lzw.eq.0) then
        ode%lzw = 8*neq+2*neq**2
      endif
      if (liw.eq.0) then
        ode%liw = 30+neq
      endif
    elseif (mf==24.or.mf==25) then
      ode%mf = mf
      if (lzw.eq.0) then
        ! mf=24,25 requires ml and mu
        ode%lzw = 10*neq + (3*ml + 2*mu)*neq
      endif
      if (liw.eq.0) then
        ode%liw = 30+neq
      endif
    endif

    call new(ode%zwork,ode%lzw)
    call new(ode%rwork,ode%lrw)
    call new(ode%iwork,ode%liw)
    call new(ode%atol,atol)
    call new(ode%rtol,rtol)
    if (size(ode%atol)==1) then
      ode%itol=1
    else
      ode%itol=2
    endif
    ode%iopt = 0

    if (norm_steps.ne.0) ode%norm_steps = norm_steps
    if (norm_tol.ne.0.) ode%norm_tol = norm_tol
  end subroutine

  subroutine get_rho_sparse(i)
    integer, intent(in) :: i
    call new(csr_val,sol_rho(i)%a)
    call new(csr_col,sol_rho(i)%ia1)
    call new(csr_ptr,sol_rho(i)%pb)
    csr_nrows = sol_rho(i)%m
    csr_ncols = sol_rho(i)%k
  end subroutine

  subroutine get_collapses(traj)
    integer, intent(in) :: traj
    integer :: i
    ! Turn linked lists into arrays
    call ll_to_array(ll_col_times(traj),col_times)
    call ll_to_array(ll_col_which(traj),col_which)
    if (traj==ntraj) then
      do i=1,ntraj
        call finalize(ll_col_times(i))
        call finalize(ll_col_which(i))
      enddo
      deallocate(ll_col_times,ll_col_which)
    endif
  end subroutine

  !
  ! Evolution
  !

  subroutine evolve(instanceno, rngseed, show_progress)
    ! What process # am I?
    integer, intent(in) :: instanceno, rngseed, show_progress
    double precision :: t, tout
    double complex, allocatable :: y(:),y_tmp(:),rho(:,:)
    logical :: states
    type(operat) :: rho_sparse
    integer :: istat=0,istat2=0,traj,progress
    integer :: i,j,l
    !integer :: m,n
    real(wp) :: mu,nu,S
    real(wp), allocatable :: p(:)
    ! ITASK  = An index specifying the task to be performed.
    !          Input only.  ITASK has the following values and meanings.
    !          1  means normal computation of output values of y(t) at
    !             t = TOUT (by overshooting and interpolating).
    !          2  means take one step only and return.
    !          3  means stop at the first internal mesh point at or
    !             beyond t = TOUT and return.
    !          4  means normal computation of output values of y(t) at
    !             t = TOUT but without overshooting t = TCRIT.
    !             TCRIT must be input as RWORK(1).  TCRIT may be equal to
    !             or beyond TOUT, but not behind it in the direction of
    !             integration.  This option is useful if the problem
    !             has a singularity at or beyond t = TCRIT.
    !          5  means take one step, without passing TCRIT, and return.
    !             TCRIT must be input as RWORK(1).
    !
    !          Note:  If ITASK = 4 or 5 and the solver reaches TCRIT
    !          (within roundoff), it will return T = TCRIT (exactly) to
    !          indicate this (unless ITASK = 4 and TOUT comes before 
    !          TCRIT, in which case answers at T = TOUT are returned 
    !          first).

    ! States or expectation values
    !if (n_e_ops == 0 .and. .not.calc_entropy) then
    if (n_e_ops == 0) then
      states = .true.
    else
      states = .false.
    endif
    ! Allocate solution array
    if (allocated(sol)) then
      deallocate(sol,stat=istat)
      if (istat.ne.0) then
        call error("evolve: could not deallocate.",istat)
      endif
    endif

    if (states) then
      if (average_states) then
        if (rho_return_sparse) then
          call new(sol_rho,size(tlist))
          call new(rho_sparse,1,1)
        else
          if (rho_reduced_dim == 0) then
            ! Not doing partial trace
            allocate(sol(1,size(tlist),ode%neq,ode%neq),stat=istat)
            allocate(rho(ode%neq,ode%neq), stat=istat2)
          else
            ! Doing partial trace
            allocate(sol(1,size(tlist),&
              rho_reduced_dim,rho_reduced_dim),stat=istat)
            allocate(rho(rho_reduced_dim,rho_reduced_dim), stat=istat2)
          endif
          sol = (0.,0.)
          rho = (0.,0.)
        endif
      else
        allocate(sol(1,ntraj,size(tlist),ode%neq), stat=istat)
        sol = (0.,0.)
      endif
    
    elseif (n_e_ops>0) then
      if (average_expect) then
        allocate(sol(n_e_ops,1,size(tlist),1), stat=istat)
        sol = (0.,0.)
      else
        allocate(sol(n_e_ops,ntraj,size(tlist),1), stat=istat)
        sol = (0.,0.)
      endif
    endif

    if (istat.ne.0) then
      call fatal_error("evolve: could not allocate sol.", istat)
    endif
 
    if (istat2.ne.0) then
      call fatal_error("evolve: could not allocate rho.", istat2)
    endif

    ! Array for average entropy
    if (calc_entropy) then
      if (.not.allocated(rho)) then
        allocate(rho(rho_reduced_dim, rho_reduced_dim), stat=istat2)
      endif
      call new(reduced_state_entropy,size(tlist))
      reduced_state_entropy = 0.
    endif

    ! Allocate linked lists for collapse times and operators
    if (allocated(ll_col_times)) then
      deallocate(ll_col_times, stat=istat)
      if (istat.ne.0) then
        call error("evolve: could not deallocate ll_col_times.", istat)
      endif
    endif

    allocate(ll_col_times(ntraj), stat=istat)
    if (istat.ne.0) then
      call fatal_error("evolve: could not allocate ll_col_times.", istat)
    endif

    if (allocated(ll_col_which)) then
      deallocate(ll_col_which, stat=istat)
      if (istat.ne.0) then
        call fatal_error("evolve: could not deallocate ll_col_which.", istat)
      endif
    endif

    allocate(ll_col_which(ntraj), stat=istat)
    if (istat.ne.0) then
      call fatal_error("evolve: could not allocate ll_col_which.", istat)
    endif

    ! Allocate work arrays
    call new(y,ode%neq)
    call new(y_tmp,ode%neq)
    ! Allocate tmp array for jump probabilities
    call new(p,n_c_ops)
    ! Initalize rng
    call init_genrand(rngseed)

    ! Initial ode setup
    if (unravel_type==1) then
      ! integrate one until specified time, w/o overshooting
      ode%itask = 4
    elseif (unravel_type==2) then
      ! integrate one step at the time, w/o overshooting
      ode%itask = 5
    endif
    ! set optinal arguments
    ! see zvode.f
    ode%rwork = 0.0
    ode%iwork = 0
    ode%rwork(5) = first_step
    ode%rwork(6) = max_step
    ode%rwork(7) = min_step
    ode%iwork(5) = order
    ode%iwork(6) = nsteps
    ode%iopt = 1
    ! first call to zvode
    ode%istate = 1

    ! Loop over trajectories
    progress = 1
    do traj=1,ntraj
      ! two random numbers
      mu = grnd()
      nu = grnd()
      ! First call to zvode
      ode%istate = 1
      ! Initial values
      y = psi0
      ! Initial value of indep. variable
      t = tlist(1)
      do i=1,size(tlist)
        ! Solution wanted at
        if (i==1) then
          ! found this to be necessary due to round off error
          tout = t
        else
          tout = tlist(i)
        endif
        select case(unravel_type)
        case(1)
          call evolve_nocollapse(t,tout,y,y_tmp,ode)
        case(2)
          call evolve_jump(t,tout,y,y_tmp,p,mu,nu,&
            ll_col_times(traj),ll_col_which(traj),ode)
        case default
          call fatal_error('Unknown unravel type.')
        end select
        y_tmp = y
        call normalize(y_tmp)

        ! Compute solution
        if (rho_reduced_dim.ne.0) then
           call ptrace_pure(y_tmp,rho,ptrace_sel,psi0_dims1)
        endif
        if (states) then
          if (average_states) then
            ! construct density matrix
            if (rho_return_sparse) then
              call densitymatrix_sparse(y_tmp,rho_sparse)
              if (traj==1) then
                sol_rho(i) = rho_sparse
              else
                sol_rho(i) = sol_rho(i) + rho_sparse
              endif
            else
              if (rho_reduced_dim == 0) then
                call densitymatrix_dense(y_tmp,rho)
              !else
              !  call ptrace_pure(y_tmp,rho,ptrace_sel,psi0_dims1)
              endif
              sol(1,i,:,:) = sol(1,i,:,:) + rho
            endif
          else
            sol(1,traj,i,:) = y_tmp
          endif
        
        else
          if (average_expect) then
            do l=1,n_e_ops
              sol(l,1,i,1) = sol(l,1,i,1)+braket(y_tmp,e_ops(l)*y_tmp)
            enddo
          else
            do l=1,n_e_ops
              sol(l,traj,i,1) = braket(y_tmp,e_ops(l)*y_tmp)
            enddo
          endif
        endif
        if (calc_entropy) then
          call entropy(rho,S)
          reduced_state_entropy(i) = reduced_state_entropy(i) + S
        endif
        ! End time loop
      enddo
      ! Indicate progress
      if (show_progress == 1 .and. instanceno == 1 .and. traj.ge.progress*ntraj/10.0) then
        write(*,*) "progress of process 1: ", progress*10, "%"
        progress=progress+1
      endif
      ! End loop over trajectories
    enddo
    ! Normalize
    if (average_states) then
      if (states .and. rho_return_sparse) then
        do j=1,size(sol_rho)
          sol_rho(j) = (1._wp/ntraj)*sol_rho(j)
        enddo
      endif
    endif
    if (allocated(sol) .and. average_expect) then
        sol = (1._wp/ntraj)*sol
    endif
    if (calc_entropy .and. (average_states .or. average_expect)) then
        reduced_state_entropy = (1._wp/ntraj)*reduced_state_entropy
    endif
    
    ! Deallocate
    call finalize(y)
    call finalize(y_tmp)
    call finalize(p)
    if (allocated(rho)) then
      deallocate(rho)
    endif
  end subroutine

  !
  ! Misc
  !

  ! Deallocate stuff

  subroutine options_finalize(this)
    type(options), intent(inout) :: this
    integer :: istat
    if (allocated(this%zwork)) then
      deallocate(this%zwork,stat=istat)
      if (istat.ne.0) then
        call error("options_finalize: could not deallocate.",istat)
      endif
    endif
    if (allocated(this%rwork)) then
      deallocate(this%rwork,stat=istat)
      if (istat.ne.0) then
        call error("options_finalize: could not deallocate.",istat)
      endif
    endif
    if (allocated(this%iwork)) then
      deallocate(this%iwork,stat=istat)
      if (istat.ne.0) then
        call error("options_finalize: could not deallocate.",istat)
      endif
    endif
    if (allocated(this%atol)) then
      deallocate(this%atol,stat=istat)
      if (istat.ne.0) then
        call error("options_finalize: could not deallocate.",istat)
      endif
    endif
    if (allocated(this%rtol)) then
      deallocate(this%rtol,stat=istat)
      if (istat.ne.0) then
        call error("options_finalize: could not deallocate.",istat)
      endif
    endif
  end subroutine

  subroutine finalize_work
    !integer :: istat=0
    call finalize(psi0)
    call finalize(hamilt)
    call finalize(c_ops)
    call finalize(e_ops)
    call finalize(ode)
  end subroutine

  subroutine finalize_sol
    integer :: istat=0
    call finalize(tlist)
    call finalize(sol_rho)
    if (allocated(ll_col_times)) then
      deallocate(ll_col_times,stat=istat)
    endif
    if (istat.ne.0) then
      call error("finalize_sol: could not deallocate.",istat)
    endif
    if (allocated(ll_col_which)) then
      deallocate(ll_col_which,stat=istat)
    endif
    if (istat.ne.0) then
      call error("finalize_sol: could not deallocate.",istat)
    endif
    if (allocated(sol)) then
      deallocate(sol,stat=istat)
    endif
    if (istat.ne.0) then
      call error("finalize_sol: could not deallocate.",istat)
    endif
  end subroutine

  ! Misc

  subroutine test_real_precision
    use qutraj_precision
    real(wp) :: b,a
    integer :: i
    write(*,*) "wp=",wp
    b = 1.0
    a = 1.0
    i = 1
    do while (b.ne.b+a)
      a = a*0.1
      if (b==b+a) then
        write(*,*) "number of decimals working precision: ",i-1
      endif
      i = i+1
    enddo
  end subroutine

end module

      subroutine zgbfa(abd,lda,n,ml,mu,ipvt,info)
      integer lda,n,ml,mu,ipvt(1),info
      complex*16 abd(lda,1)
c
c     zgbfa factors a complex*16 band matrix by elimination.
c
c     zgbfa is usually called by zgbco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c
c     on entry
c
c        abd     complex*16(lda, n)
c                contains the matrix in band storage.  the columns
c                of the matrix are stored in the columns of  abd  and
c                the diagonals of the matrix are stored in rows
c                ml+1 through 2*ml+mu+1 of  abd .
c                see the comments below for details.
c
c        lda     integer
c                the leading dimension of the array  abd .
c                lda must be .ge. 2*ml + mu + 1 .
c
c        n       integer
c                the order of the original matrix.
c
c        ml      integer
c                number of diagonals below the main diagonal.
c                0 .le. ml .lt. n .
c
c        mu      integer
c                number of diagonals above the main diagonal.
c                0 .le. mu .lt. n .
c                more efficient if  ml .le. mu .
c     on return
c
c        abd     an upper triangular matrix in band storage and
c                the multipliers which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that zgbsl will divide by zero if
c                     called.  use  rcond  in zgbco for a reliable
c                     indication of singularity.
c
c     band storage
c
c           if  a  is a band matrix, the following program segment
c           will set up the input.
c
c                   ml = (band width below the diagonal)
c                   mu = (band width above the diagonal)
c                   m = ml + mu + 1
c                   do 20 j = 1, n
c                      i1 = max0(1, j-mu)
c                      i2 = min0(n, j+ml)
c                      do 10 i = i1, i2
c                         k = i - j + m
c                         abd(k,j) = a(i,j)
c                10    continue
c                20 continue
c
c           this uses rows  ml+1  through  2*ml+mu+1  of  abd .
c           in addition, the first  ml  rows in  abd  are used for
c           elements generated during the triangularization.
c           the total number of rows needed in  abd  is  2*ml+mu+1 .
c           the  ml+mu by ml+mu  upper left triangle and the
c           ml by ml  lower right triangle are not referenced.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas zaxpy,zscal,izamax
c     fortran dabs,max0,min0
c
c     internal variables
c
      complex*16 t
      integer i,izamax,i0,j,ju,jz,j0,j1,k,kp1,l,lm,m,mm,nm1
c
      complex*16 zdum
      double precision cabs1
      double precision dreal,dimag
      complex*16 zdumr,zdumi
      dreal(zdumr) = zdumr
      dimag(zdumi) = (0.0d0,-1.0d0)*zdumi
      cabs1(zdum) = dabs(dreal(zdum)) + dabs(dimag(zdum))
c
      m = ml + mu + 1
      info = 0
c
c     zero initial fill-in columns
c
      j0 = mu + 2
      j1 = min0(n,m) - 1
      if (j1 .lt. j0) go to 30
      do 20 jz = j0, j1
         i0 = m + 1 - jz
         do 10 i = i0, ml
            abd(i,jz) = (0.0d0,0.0d0)
   10    continue
   20 continue
   30 continue
      jz = j1
      ju = 0
c
c     gaussian elimination with partial pivoting
c
      nm1 = n - 1
      if (nm1 .lt. 1) go to 130
      do 120 k = 1, nm1
         kp1 = k + 1
c
c        zero next fill-in column
c
         jz = jz + 1
         if (jz .gt. n) go to 50
         if (ml .lt. 1) go to 50
            do 40 i = 1, ml
               abd(i,jz) = (0.0d0,0.0d0)
   40       continue
   50    continue
c
c        find l = pivot index
c
         lm = min0(ml,n-k)
         l = izamax(lm+1,abd(m,k),1) + m - 1
         ipvt(k) = l + k - m
c
c        zero pivot implies this column already triangularized
c
         if (cabs1(abd(l,k)) .eq. 0.0d0) go to 100
c
c           interchange if necessary
c
            if (l .eq. m) go to 60
               t = abd(l,k)
               abd(l,k) = abd(m,k)
               abd(m,k) = t
   60       continue
c
c           compute multipliers
c
            t = -(1.0d0,0.0d0)/abd(m,k)
            call zscal(lm,t,abd(m+1,k),1)
c
c           row elimination with column indexing
c
            ju = min0(max0(ju,mu+ipvt(k)),n)
            mm = m
            if (ju .lt. kp1) go to 90
            do 80 j = kp1, ju
               l = l - 1
               mm = mm - 1
               t = abd(l,j)
               if (l .eq. mm) go to 70
                  abd(l,j) = abd(mm,j)
                  abd(mm,j) = t
   70          continue
               call zaxpy(lm,t,abd(m+1,k),1,abd(mm+1,j),1)
   80       continue
   90       continue
         go to 110
  100    continue
            info = k
  110    continue
  120 continue
  130 continue
      ipvt(n) = n
      if (cabs1(abd(m,n)) .eq. 0.0d0) info = n
      return
      end

module qutraj_linalg
  !
  ! This module depends on LAPACK
  !

  use qutraj_precision
  use qutraj_general
  use qutraj_hilbert

  implicit none

  contains

  subroutine eigenvalues(rho,eig,n)
    ! Eigenvalues of dense hermitian matrix rho
    complex(wp), intent(in) :: rho(:,:)
    integer, intent(in) :: n
    real(wp), intent(out) :: eig(n)
    double complex :: ap(n*(n+1)/2), z(1,1),work(2*n-1)
    double precision :: eig_dp(n),rwork(3*n-2)
    integer info,i,j
    do i=1,n
      do j=i,n
        ap(i+(j-1)*j/2) = rho(i,j)
      enddo
    enddo
    call zhpev('N','U',n,ap,eig_dp,z,1,work,rwork,info)
    eig = eig_dp
  end subroutine

  subroutine entropy(rho,S)
    ! Calculate entropy for dense density matrix
    complex(wp), intent(in) :: rho(:,:)
    real(wp), intent(out) :: S
    real(wp), dimension(2) :: eig_r
    integer :: i
    call eigenvalues(rho,eig_r,size(rho,1))
    S = 0
    do i=1,size(eig_r)
      ! Rule: 0 log(0) = 0
      if (eig_r(i) < -epsi) &
        write(*,*) "entropy: negative eigenvalue!", eig_r(i)
      if (abs(eig_r(i)) > epsi) then
        S = S -eig_r(i)*log(eig_r(i))/log(2.)
      endif
    enddo
  end subroutine


end module

module qutraj_linalg
  !
  ! Dummy module
  !

  use qutraj_precision
  use qutraj_general
  use qutraj_hilbert

  implicit none

  contains

  subroutine eigenvalues(rho,eig,n)
    ! Eigenvalues of dense hermitian matrix rho
    complex(wp), intent(in) :: rho(:,:)
    integer, intent(in) :: n
    real(wp), intent(out) :: eig(n)
    call error('eigenvalues: subroutine not available.')
  end subroutine

  subroutine entropy(rho,S)
    ! Calculate entropy for dense density matrix
    complex(wp), intent(in) :: rho(:,:)
    real(wp), intent(out) :: S
    call error('eigenvalues: subroutine not available.')
  end subroutine

end module

set MING=0
echo CONDA_PY "%CONDA_PY%"
if "%CONDA_PY%"=="27" set MING=1

if %MING%==1 (
    echo using mingw compiler
    "%PYTHON%" setup.py build --compiler=mingw32
    if errorlevel 1 exit 1
    "%PYTHON%" setup.py build_ext --compiler=mingw32
    if errorlevel 1 exit 1
    "%PYTHON%" setup.py install
    if errorlevel 1 exit 1
) ELSE (
    echo using default compiler
    "%PYTHON%" setup.py build
    if errorlevel 1 exit 1
    "%PYTHON%" setup.py build_ext
    if errorlevel 1 exit 1
    "%PYTHON%" setup.py install
    if errorlevel 1 exit 1
)

**Checklist**
Thank you for contributing to QuTiP! Please make sure you have finished the following tasks before opening the PR.

- [ ] Please read [Contributing to QuTiP Development](https://qutip.readthedocs.io/en/stable/development/contributing.html)
- [ ] Contributions to qutip should follow the [pep8 style](https://www.python.org/dev/peps/pep-0008/).
You can use [pycodestyle](http://pycodestyle.pycqa.org/en/latest/index.html) to check your code automatically
- [ ] Please add tests to cover your changes if applicable.
- [ ] If the behavior of the code has changed or new feature has been added, please also update the documentation in the `doc` folder, and the [notebook](https://github.com/qutip/qutip-tutorials). Feel free to ask if you are not sure.
- [ ] Include the changelog in a file named: `doc/changes/<PR number>.<type>` 'type' can be one of the following: feature, bugfix, doc, removal, misc, or deprecation (see [here](https://qutip.readthedocs.io/en/stable/development/contributing.html#changelog-generation) for more information).

Delete this checklist after you have completed all the tasks. If you have not finished them all, you can also open a [Draft Pull Request](https://github.blog/2019-02-14-introducing-draft-pull-requests/) to let the others know this on-going work and keep this checklist in the PR description.

**Description**
Describe here the proposed change.

**Related issues or PRs**
Please mention the related issues or PRs here. If the PR fixes an issue, use the keyword fix/fixes/fixed followed by the issue id, e.g. fix #1184

**AI Tools Usage Disclosure**
If AI tools were used, please mention
`Model/Tool Name: Describe how they were used`.

# Contributor Covenant Code of Conduct

As contributors and maintainers of this project, and in the interest of fostering an open and welcoming community, we pledge to respect all people who contribute through reporting issues, posting feature requests, updating documentation, submitting pull requests or patches, and other activities.

We are committed to making participation in this project a harassment-free experience for everyone, regardless of level of experience, gender, gender identity and expression, sexual orientation, disability, personal appearance, body size, race, ethnicity, age, religion, or nationality.

Examples of unacceptable behavior by participants include:

* The use of sexualized language or imagery
* Personal attacks
* Trolling or insulting/derogatory comments
* Public or private harassment
* Publishing other's private information, such as physical or electronic addresses, without explicit permission
* Other unethical or unprofessional conduct

Project maintainers have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct. By adopting this Code of Conduct, project maintainers commit themselves to fairly and consistently applying these principles to every aspect of managing this project. Project maintainers who do not follow or enforce the Code of Conduct may be permanently removed from the project team.

This code of conduct applies both within project spaces and in public spaces when an individual is representing the project or its community. 

Instances of abusive, harassing, or otherwise unacceptable behavior may be reported by opening an issue or contacting one or more of the project maintainers. 

This Code of Conduct is adapted from the Contributor Covenant , version 1.2.0, available at https://www.contributor-covenant.org/version/1/2/0/code-of-conduct.html 

[homepage]: https://contributor-covenant.org
[version]: https://contributor-covenant.org/version/1/2/

# Contributing to QuTiP Development

You are most welcome to contribute to QuTiP development by forking this repository and sending pull requests, or filing bug reports at the [issues page](https://github.com/qutip/qutip/issues).
You can also help out with users' questions, or discuss proposed changes in the [QuTiP discussion group](https://groups.google.com/g/qutip).
All code contributions are acknowledged in the [contributors](https://qutip.readthedocs.io/en/stable/contributors.html) section in the documentation.

For more information, including technical advice, please see the ["contributing to QuTiP development" section of the documentation](https://qutip.readthedocs.io/en/stable/development/contributing.html).


## AI Tools Usage Policy
We acknowledge the use of AI tools to improve efficiency and enhance quality of work. Contributors may use such tools, provided they adhere to the following guidelines:

### 1. Accountability

The human contributor is solely responsible for their contribution i.e. all the AI-generated outputs can be considered their own work. If you're submitting a Pull Request that includes AI-generated code or documentation:

- You are responsible for ensuring that code you submit meets the project's standards.
- You must fully understand every line of code in the submission.
- You must be able to explain the "why" behind the implementation during the review process.

### 2. Transparency

All Pull Requests must fill the **AI Tools Usage Disclosure** in the PR template. This disclosure is mandatory and must accurately reflect how AI Tools were used.

### 3. Copyright & Legal

By submitting a contribution to qutip, you agree to

1. Submit your contribution under the project's license.

2. The contribution does not violate any third-party rights or the terms of service of the AI provider. And does not include "regurgitated" code from libraries with incompatible licenses (e.g., GPL-licensed code) being suggested into our BSD-3-clause licensed project.

3. AI agents must not sign commits or be added to commit message trailer `Co-authored-by:` since copyright is fundamentally tied to the concept of human authorship as per the US Copyright law. You can instead use `Assisted-by: AI Model/Tool` as commit message trailer e.g. `Assisted-by: Cursor with Opus 4.6`.

### 4. Good Use Cases

- **Understand the codebase:** AI can be used to explore unfamiliar parts of the repository, summarize modules and clarify how components interact. It helps build the mental model of the project faster. 

- **Brainstorming and Design:**  AI may assist in generating ideas, evaluating different approaches and structuring designs. However, all final decisions regarding design and architecture should be independently validated and be made by the contributor.

- **Reviewing your implementation:**  AI can be used to spot potential bugs, suggest improvements and help clarify unexpected behavior in code. Contributors should verify the correctness and relevance of AI-generated feedback before applying it.

### 5. Prohibited Use

The following use cases are prohibited:

- **Communication:** In project communications (GitHub Issues, Discussion, PR descriptions and review comments), we personally expect to communicate directly with other humans not with automated systems. Use of translation tools is completely welcome.

- **Ban on Bots/Agents:** Fully autonomous or unsupervised AI agents (e.g. OpenClaw, SWE-agent) are not allowed to submit Pull Requests.

- **Stance on Good First Issues:** The main purpose of a “good first issue” is to allow new human contributors to get familiar with `qutip`, with the GitHub workflow and to engage with the community. Submitting a fully AI-generated PR defeats that purpose. AI can be used as a learning aid to understand the codebase, but the final implementation must be your own.

### 6. Enforcement

Maintainers reserve the right to close any Pull Request that violates this Policy. Maintainers may restrict participation or report users to GitHub for repeated violations of this policy.
